package gr.cite.annotation.common.enums;

import com.fasterxml.jackson.annotation.JsonValue;
import gr.cite.annotation.data.conventers.DatabaseEnum;

import java.util.Map;

public enum TenantConfigurationType implements DatabaseEnum<Short> {
    EMAIL_CLIENT_CONFIGURATION((short)1),
    DEFAULT_USER_LOCALE((short)3),
    NOTIFIER_LIST((short)4);

    private final Short value;

    TenantConfigurationType(Short value) {
        this.value = value;
    }

    @JsonValue
    public Short getValue() {
        return value;
    }

    private static final Map<Short, TenantConfigurationType> map = EnumUtils.getEnumValueMap(TenantConfigurationType.class);

    public static TenantConfigurationType of(Short i) {
        return map.get(i);
    }
}
