package gr.cite.annotation.model;

import gr.cite.annotation.common.enums.AnnotationProtectionType;
import gr.cite.annotation.common.enums.IsActive;
import gr.cite.annotation.data.conventers.AnnotationProtectionTypeConverter;
import jakarta.persistence.Column;
import jakarta.persistence.Convert;

import java.time.Instant;
import java.util.List;
import java.util.UUID;

public class Annotation {

    private UUID id;

    public static final String _id = "id";

    private UUID entityId;

    public static final String _entityId = "entityId";

    private String entityType;

    public static final String _entityType = "entityType";

    private String anchor;

    public static final String _anchor = "anchor";

    private String payload;

    public static final String _payload = "payload";

    private UUID subjectId;

    public static final String _subjectId = "subjectId";

    private UUID threadId;

    public static final String _threadId = "threadId";

    private UUID parentId;

    public static final String _parentId = "parentId";

    private AnnotationProtectionType protectionType;

    public static final String _protectionType = "protectionType";

    private Instant timeStamp;

    public static final String _timeStamp = "timeStamp";

    private AnnotationAuthor author;

    public static final String _author = "author";

    private Instant createdAt;

    public static final String _createdAt = "createdAt";

    private Instant updatedAt;

    public static final String _updatedAt = "updatedAt";

    private IsActive isActive;

    public static final String _isActive = "isActive";

    private String hash;

    public static final String _hash = "hash";

    private List<String> authorizationFlags;
    public static final String _authorizationFlags = "authorizationFlags";


    private Boolean belongsToCurrentTenant;
    public static final String _belongsToCurrentTenant = "belongsToCurrentTenant";

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    public UUID getEntityId() {
        return entityId;
    }

    public void setEntityId(UUID entityId) {
        this.entityId = entityId;
    }

    public String getEntityType() {
        return entityType;
    }

    public void setEntityType(String entityType) {
        this.entityType = entityType;
    }

    public String getAnchor() {
        return anchor;
    }

    public void setAnchor(String anchor) {
        this.anchor = anchor;
    }

    public String getPayload() {
        return payload;
    }

    public void setPayload(String payload) {
        this.payload = payload;
    }

    public UUID getSubjectId() {
        return subjectId;
    }

    public void setSubjectId(UUID subjectId) {
        this.subjectId = subjectId;
    }

    public AnnotationAuthor getAuthor() {
        return author;
    }

    public void setAuthor(AnnotationAuthor author) {
        this.author = author;
    }

    public UUID getThreadId() {
        return threadId;
    }

    public void setThreadId(UUID threadId) {
        this.threadId = threadId;
    }

    public UUID getParentId() {
        return parentId;
    }

    public void setParentId(UUID parentId) {
        this.parentId = parentId;
    }

    public AnnotationProtectionType getProtectionType() {
        return protectionType;
    }

    public void setProtectionType(AnnotationProtectionType protectionType) {
        this.protectionType = protectionType;
    }

    public Instant getTimeStamp() {
        return timeStamp;
    }

    public void setTimeStamp(Instant timeStamp) {
        this.timeStamp = timeStamp;
    }

    public Instant getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Instant createdAt) {
        this.createdAt = createdAt;
    }

    public Instant getUpdatedAt() {
        return updatedAt;
    }

    public void setUpdatedAt(Instant updatedAt) {
        this.updatedAt = updatedAt;
    }

    public IsActive getIsActive() {
        return isActive;
    }

    public void setIsActive(IsActive isActive) {
        this.isActive = isActive;
    }

    public String getHash() {
        return hash;
    }

    public void setHash(String hash) {
        this.hash = hash;
    }

    public List<String> getAuthorizationFlags() {
        return authorizationFlags;
    }

    public void setAuthorizationFlags(List<String> authorizationFlags) {
        this.authorizationFlags = authorizationFlags;
    }

}
