package eu.eudat.commons.enums;

import com.fasterxml.jackson.annotation.JsonValue;
import eu.eudat.data.converters.enums.DatabaseEnum;

import java.util.Map;

public enum ActionConfirmationType implements DatabaseEnum<Short> {

    MergeAccount((short) 0),
    RemoveCredential((short) 1),
    DmpInvitation((short) 2);

    private final Short value;

    ActionConfirmationType(Short value) {
        this.value = value;
    }

    @Override
    @JsonValue
    public Short getValue() {
        return value;
    }

    private static final Map<Short, ActionConfirmationType> map = EnumUtils.getEnumValueMap(ActionConfirmationType.class);

    public static ActionConfirmationType of(Short i) {
        return map.get(i);
    }


}
