package eu.eudat.commons.enums;

import com.fasterxml.jackson.annotation.JsonValue;
import eu.eudat.data.converters.enums.DatabaseEnum;

import java.util.Map;

public enum DmpBlueprintSystemFieldType implements DatabaseEnum<Short> {

    Title((short)0),
    Description((short)1),
    Language((short)2),
    Contact((short)3),
    AccessRights((short)4),
    User((short)5);
    private final Short value;

    DmpBlueprintSystemFieldType(Short value) {
        this.value = value;
    }

    @JsonValue
    public Short getValue() {
        return value;
    }

    private static final Map<Short, DmpBlueprintSystemFieldType> map = EnumUtils.getEnumValueMap(DmpBlueprintSystemFieldType.class);

    public static DmpBlueprintSystemFieldType of(Short i) {
        return map.get(i);
    }
}