package eu.eudat.commons.enums;

import com.fasterxml.jackson.annotation.JsonValue;
import eu.eudat.data.converters.enums.DatabaseEnum;

import java.util.Map;

public enum DmpStatus implements DatabaseEnum<Short> {

    Draft((short) 0), Finalized((short) 1);

    private final Short value;

    DmpStatus(Short value) {
        this.value = value;
    }

    @Override
    @JsonValue
    public Short getValue() {
        return value;
    }

    private static final Map<Short, DmpStatus> map = EnumUtils.getEnumValueMap(DmpStatus.class);

    public static DmpStatus of(Short i) {
        return map.get(i);
    }


}
