package eu.eudat.commons.enums;

import com.fasterxml.jackson.annotation.JsonValue;
import eu.eudat.data.converters.enums.DatabaseEnum;

import java.util.Map;

public enum DmpUserRole implements DatabaseEnum<Short> {

    Owner((short) 0),
    User((short) 1),
    DescriptionContributor((short) 2),
    Reviewer((short) 3);

    private final Short value;

    DmpUserRole(Short value) {
        this.value = value;
    }

    @Override
    @JsonValue
    public Short getValue() {
        return value;
    }

    private static final Map<Short, DmpUserRole> map = EnumUtils.getEnumValueMap(DmpUserRole.class);

    public static DmpUserRole of(Short i) {
        return map.get(i);
    }

}
