package eu.eudat.commons.enums;

import com.fasterxml.jackson.annotation.JsonValue;
import eu.eudat.data.converters.enums.DatabaseEnum;

import java.util.Map;

public enum DmpValidationOutput implements DatabaseEnum<Short> {

    Valid((short) 1),
    Invalid((short) 2);

    private final Short value;

    DmpValidationOutput(Short value) {
        this.value = value;
    }

    @JsonValue
    public Short getValue() {
        return value;
    }

    private static final Map<Short, DmpValidationOutput> map = EnumUtils.getEnumValueMap(DmpValidationOutput.class);

    public static DmpValidationOutput of(Short i) {
        return map.get(i);
    }

}
