package eu.eudat.commons.enums;

import com.fasterxml.jackson.annotation.JsonValue;
import eu.eudat.data.converters.enums.DatabaseEnum;

import java.util.Map;

public enum DmpVersionStatus implements DatabaseEnum<Short> {

    Current((short) 0),
    Previous((short) 1),
    NotFinalized((short) 2);

    private final Short value;

    DmpVersionStatus(Short value) {
        this.value = value;
    }

    @Override
    @JsonValue
    public Short getValue() {
        return value;
    }

    private static final Map<Short, DmpVersionStatus> map = EnumUtils.getEnumValueMap(DmpVersionStatus.class);

    public static DmpVersionStatus of(Short i) {
        return map.get(i);
    }

}
