package eu.eudat.commons.enums;

import com.fasterxml.jackson.annotation.JsonValue;
import eu.eudat.data.converters.enums.DatabaseEnum;

import java.util.Map;

public enum LockTargetType implements DatabaseEnum<Short> {
	Dmp((short) 0),
	Description((short) 1),
	DmpBlueprint((short) 2),
	DescriptionTemplate((short) 3);
	private final Short value;

	LockTargetType(Short value) {
		this.value = value;
	}

	@JsonValue
	public Short getValue() {
		return value;
	}

	private static final Map<Short, LockTargetType> map = EnumUtils.getEnumValueMap(LockTargetType.class);

	public static LockTargetType of(Short i) {
		return map.get(i);
	}
}
