package eu.eudat.commons.types.descriptiontemplate;

import eu.eudat.commons.enums.FieldValidationType;
import eu.eudat.commons.types.descriptiontemplate.fielddata.*;
import jakarta.xml.bind.annotation.*;

import java.util.List;

@XmlAccessorType(XmlAccessType.FIELD)
public class FieldEntity {
    @XmlAttribute(name="id")
    private String id;
    @XmlAttribute(name="ordinal")
    private int ordinal;
    @XmlElementWrapper(name = "schematics")
    @XmlElement(name = "schematic")
    private List<String> schematics;
    @XmlAttribute(name="numbering")
    private String numbering;
    @XmlAttribute(name="defaultValue")
    private String defaultValue;
    @XmlElementWrapper(name = "visibilityRules")
    @XmlElement(name = "rule")
    private List<RuleEntity> visibilityRules;

    @XmlElements({
            @XmlElement(name = LabelDataEntity.XmlElementName, type = LabelDataEntity.class),
            @XmlElement(name = LabelAndMultiplicityDataEntity.XmlElementName, type = LabelAndMultiplicityDataEntity.class),
            @XmlElement(name = UploadDataEntity.XmlElementName, type = UploadDataEntity.class),
            @XmlElement(name = RadioBoxDataEntity.XmlElementName, type = RadioBoxDataEntity.class),
            @XmlElement(name = SelectDataEntity.XmlElementName, type = SelectDataEntity.class),
            @XmlElement(name = ReferenceTypeDataEntity.XmlElementName, type = ReferenceTypeDataEntity.class)
    })
    private BaseFieldDataEntity data;
    @XmlElementWrapper(name = "validations")
    @XmlElement(name = "validation")
    private List<FieldValidationType> validations;
    @XmlAttribute(name="includeInExport")
    private Boolean includeInExport;

    public String getId() {
        return id;
    }
    public void setId(String id) {
        this.id = id;
    }

    public int getOrdinal() {
        return ordinal;
    }
    public void setOrdinal(int ordinal) {
        this.ordinal = ordinal;
    }

    public List<String> getSchematics() {
        return schematics;
    }
    public void setSchematics(List<String> schematics) {
        this.schematics = schematics;
    }

    public BaseFieldDataEntity getData() {
        return data;
    }
    public void setData(BaseFieldDataEntity data) {
        this.data = data;
    }

    public String getDefaultValue() {
        return defaultValue;
    }
    public void setDefaultValue(String defaultValue) {
        this.defaultValue = defaultValue;
    }


    public List<FieldValidationType> getValidations() {
        return validations;
    }
    public void setValidations(List<FieldValidationType> validations) {
        this.validations = validations;
    }

    public String getNumbering() {
        return numbering;
    }
    public void setNumbering(String numbering) {
        this.numbering = numbering;
    }

    public Boolean getIncludeInExport() {
        return includeInExport;
    }

    public void setIncludeInExport(Boolean includeInExport) {
        this.includeInExport = includeInExport;
    }

    public List<RuleEntity> getVisibilityRules() {
        return visibilityRules;
    }

    public void setVisibilityRules(List<RuleEntity> visibilityRules) {
        this.visibilityRules = visibilityRules;
    }
}
