package eu.eudat.commons.types.descriptiontemplate;

import jakarta.xml.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

@XmlAccessorType(XmlAccessType.FIELD)
public class FieldSetEntity {
    @XmlAttribute(name="id")
    private String id;
    @XmlAttribute(name="ordinal")
    private int ordinal;

    @XmlElementWrapper(name = "fields")
    @XmlElement(name = "field")
    private List<FieldEntity> fields;
    @XmlAttribute(name="numbering")
    private String numbering;
    @XmlAttribute(name="title")
    private String title;
    @XmlAttribute(name="description")
    private String description;
    @XmlAttribute(name="extendedDescription")
    private String extendedDescription;
    @XmlAttribute(name="additionalInformation")
    private String additionalInformation;
    @XmlElement(name="multiplicity")
    private MultiplicityEntity multiplicity;
    @XmlAttribute(name="hasCommentField")
    private boolean hasCommentField;

    public List<FieldEntity> getFields() {
        return fields;
    }
    public void setFields(List<FieldEntity> fieldEntities) {
        this.fields = fieldEntities;
    }

    public String getId() {
        return id;
    }
    public void setId(String id) {
        this.id = id;
    }

    public int getOrdinal() {
        return ordinal;
    }
    public void setOrdinal(int ordinal) {
        this.ordinal = ordinal;
    }

    public String getTitle() {
        return title;
    }
    public void setTitle(String title) {
        this.title = title;
    }

    public String getDescription() {
        return description;
    }
    public void setDescription(String description) {
        this.description = description;
    }

    public String getExtendedDescription() {
        return extendedDescription;
    }
    public void setExtendedDescription(String extendedDescription) {
        this.extendedDescription = extendedDescription;
    }

    public MultiplicityEntity getMultiplicity() {
        return multiplicity;
    }
    public void setMultiplicity(MultiplicityEntity multiplicity) {
        this.multiplicity = multiplicity;
    }

    public boolean getHasCommentField() {
        return hasCommentField;
    }
    public void setHasCommentField(boolean hasCommentField) {
        this.hasCommentField = hasCommentField;
    }

    public String getNumbering() {
        return numbering;
    }
    public void setNumbering(String numbering) {
        this.numbering = numbering;
    }

    public String getAdditionalInformation() {
        return additionalInformation;
    }
    public void setAdditionalInformation(String additionalInformation) {
        this.additionalInformation = additionalInformation;
    }


    public List<FieldEntity> getAllField() {
        return this.getFields() == null ? new ArrayList<>() : this.getFields();
    }

    public List<FieldEntity> getFieldById(String id) {
        return this.getAllField().stream().filter(x-> id.equals(x.getId())).toList();
    }
}
