package eu.eudat.commons.types.descriptiontemplate.importexport;

import eu.eudat.commons.enums.FieldType;
import eu.eudat.commons.enums.FieldValidationType;
import eu.eudat.commons.types.descriptiontemplate.importexport.fielddata.*;
import jakarta.xml.bind.annotation.*;

import java.util.List;

@XmlAccessorType(XmlAccessType.FIELD)
public class FieldImportExport {

    @XmlAttribute(name = "id")
    private String id;

    @XmlAttribute(name = "ordinal")
    private int ordinal;

    @XmlElement(name = "numbering")
    private String numbering;

    @XmlElementWrapper(name = "validations")
    @XmlElement(name = "validation")
    private List<FieldValidationType> validations;

    @XmlElement(name = "defaultValue")
    private String defaultValue;

    @XmlElementWrapper(name = "visibilityRules")
    @XmlElement(name = "visibilityRule")
    private List<RuleImportExport> visibilityRules;

    @XmlElement(name = "fieldType")
    private FieldType fieldType;

    @XmlElements({
            @XmlElement(name = LabelDataImportExport.XmlElementName, type = LabelDataImportExport.class),
            @XmlElement(name = LabelAndMultiplicityDataImportExport.XmlElementName, type = LabelAndMultiplicityDataImportExport.class),
            @XmlElement(name = UploadDataImportExport.XmlElementName, type = UploadDataImportExport.class),
            @XmlElement(name = RadioBoxDataImportExport.XmlElementName, type = RadioBoxDataImportExport.class),
            @XmlElement(name = SelectDataImportExport.XmlElementName, type = SelectDataImportExport.class),
            @XmlElement(name = ReferenceTypeDataImportExport.XmlElementName, type = ReferenceTypeDataImportExport.class),
    })
    private BaseFieldDataImportExport data;

    @XmlElementWrapper(name = "schematics")
    @XmlElement(name = "schematic")
    private List<String> schematics;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public int getOrdinal() {
        return ordinal;
    }

    public void setOrdinal(int ordinal) {
        this.ordinal = ordinal;
    }

    public String getNumbering() {
        return numbering;
    }

    public void setNumbering(String numbering) {
        this.numbering = numbering;
    }

    public String getDefaultValue() {
        return defaultValue;
    }

    public void setDefaultValue(String defaultValue) {
        this.defaultValue = defaultValue;
    }

    public FieldType getFieldType() {
        return fieldType;
    }

    public void setFieldType(FieldType fieldType) {
        this.fieldType = fieldType;
    }

    public BaseFieldDataImportExport getData() {
        return this.data;
    }

    public void setData(BaseFieldDataImportExport data) {
        this.data = data;
    }

    public List<FieldValidationType> getValidations() {
        return validations;
    }

    public void setValidations(List<FieldValidationType> validations) {
        this.validations = validations;
    }

    public List<String> getSchematics() {
        return schematics;
    }

    public void setSchematics(List<String> schematics) {
        this.schematics = schematics;
    }

    public List<RuleImportExport> getVisibilityRules() {
        return visibilityRules;
    }

    public void setVisibilityRules(List<RuleImportExport> visibilityRules) {
        this.visibilityRules = visibilityRules;
    }

}
