package eu.eudat.commons.types.dmpblueprint;

import eu.eudat.commons.enums.DmpBlueprintFieldCategory;
import jakarta.xml.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

@XmlAccessorType(XmlAccessType.FIELD)
public class SectionEntity {

    @XmlAttribute(name="id")
    private UUID id;

    @XmlAttribute(name="label")
    private String label;

    @XmlAttribute(name="description")
    private String description;

    @XmlAttribute(name="ordinal")
    private Integer ordinal;

    @XmlElementWrapper(name = "fields")
    @XmlElements({
            @XmlElement(name = DmpBlueprintFieldCategory.Names.Extra, type = ExtraFieldEntity.class),
            @XmlElement(name = DmpBlueprintFieldCategory.Names.System, type = SystemFieldEntity.class),
            @XmlElement(name = DmpBlueprintFieldCategory.Names.ReferenceType, type = ReferenceTypeFieldEntity.class),
    })
    private List<FieldEntity> fields;
    
    @XmlAttribute(name="hasTemplates")
    private Boolean hasTemplates;
    
    @XmlElementWrapper(name = "descriptionTemplates")
    @XmlElement(name = "descriptionTemplate")
    private List<DescriptionTemplateEntity> descriptionTemplates;

    @XmlElementWrapper(name = "prefillingSourcesIds")
    @XmlElement(name = "id")
    private List<UUID> prefillingSourcesIds;

    public UUID getId() {
        return id;
    }
    public void setId(UUID id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }
    public void setLabel(String label) {
        this.label = label;
    }

    public String getDescription() {
        return description;
    }
    public void setDescription(String description) {
        this.description = description;
    }

    public Integer getOrdinal() {
        return ordinal;
    }
    public void setOrdinal(Integer ordinal) {
        this.ordinal = ordinal;
    }

    public List<FieldEntity> getFields() {
        return fields;
    }
    public void setFields(List<FieldEntity> fields) {
        this.fields = fields;
    }

    public Boolean getHasTemplates() {
        return hasTemplates;
    }
    public void setHasTemplates(Boolean hasTemplates) {
        this.hasTemplates = hasTemplates;
    }

    public List<DescriptionTemplateEntity> getDescriptionTemplates() {
        return descriptionTemplates;
    }
    public void setDescriptionTemplates(List<DescriptionTemplateEntity> descriptionTemplates) {
        this.descriptionTemplates = descriptionTemplates;
    }

    public List<UUID> getPrefillingSourcesIds() {
        return prefillingSourcesIds;
    }

    public void setPrefillingSourcesIds(List<UUID> prefillingSourcesIds) {
        this.prefillingSourcesIds = prefillingSourcesIds;
    }

    public List<FieldEntity> getAllField(){
        return this.getFields() != null ? this.getFields() : new ArrayList<>();
    }

}
