package eu.eudat.commons.types.dmpblueprint.importexport;

import jakarta.xml.bind.annotation.*;

import java.util.List;
import java.util.UUID;

@XmlAccessorType(XmlAccessType.FIELD)
public class SectionImportExport {

    @XmlAttribute(name = "id")
    private UUID id;
    @XmlAttribute(name = "label")
    private String label;
    @XmlAttribute(name = "description")
    private String description;
    @XmlAttribute(name = "ordinal")
    private int ordinal;
    @XmlElementWrapper(name = "systemFields")
    @XmlElement(name = "systemField")
    private List<SystemFieldImportExport> systemFields;
    @XmlElementWrapper(name = "extraFields")
    @XmlElement(name = "extraField")
    private List<ExtraFieldImportExport> extraFields;
    @XmlElementWrapper(name = "referenceFields")
    @XmlElement(name = "referenceField")
    private List<ReferenceTypeFieldImportExport> referenceFields;
    @XmlAttribute(name = "hasTemplates")
    private boolean hasTemplates;
    @XmlElementWrapper(name = "descriptionTemplates")
    @XmlElement(name = "descriptionTemplate")
    private List<DescriptionTemplateImportExport> descriptionTemplates;

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public int getOrdinal() {
        return ordinal;
    }

    public void setOrdinal(int ordinal) {
        this.ordinal = ordinal;
    }

    public List<SystemFieldImportExport> getSystemFields() {
        return systemFields;
    }

    public void setSystemFields(List<SystemFieldImportExport> systemFields) {
        this.systemFields = systemFields;
    }

    public List<ExtraFieldImportExport> getExtraFields() {
        return extraFields;
    }

    public void setExtraFields(List<ExtraFieldImportExport> extraFields) {
        this.extraFields = extraFields;
    }

    public List<ReferenceTypeFieldImportExport> getReferenceFields() {
        return referenceFields;
    }

    public void setReferenceFields(List<ReferenceTypeFieldImportExport> referenceFields) {
        this.referenceFields = referenceFields;
    }

    public boolean isHasTemplates() {
        return hasTemplates;
    }

    public void setHasTemplates(boolean hasTemplates) {
        this.hasTemplates = hasTemplates;
    }

    public List<DescriptionTemplateImportExport> getDescriptionTemplates() {
        return descriptionTemplates;
    }

    public void setDescriptionTemplates(List<DescriptionTemplateImportExport> descriptionTemplates) {
        this.descriptionTemplates = descriptionTemplates;
    }

}
