package eu.eudat.data;

import eu.eudat.commons.enums.DmpBlueprintStatus;
import eu.eudat.commons.enums.DmpBlueprintVersionStatus;
import eu.eudat.commons.enums.IsActive;
import eu.eudat.data.converters.DmpBlueprintVersionStatusConverter;
import eu.eudat.data.converters.enums.DmpBlueprintStatusConverter;
import eu.eudat.data.converters.enums.IsActiveConverter;
import eu.eudat.data.tenant.TenantScopedBaseEntity;
import eu.eudat.data.types.SQLXMLType;
import jakarta.persistence.*;
import org.hibernate.annotations.Type;

import java.time.Instant;
import java.util.UUID;

@Entity
@Table(name = "\"DmpBlueprint\"")
public class DmpBlueprintEntity extends TenantScopedBaseEntity {

    @Id
    @Column(name = "id", columnDefinition = "uuid", updatable = false, nullable = false)
    private UUID id;

    public static final String _id = "id";

    @Column(name = "label", length = DmpBlueprintEntity._labelLength, nullable = false)
    private String label;

    public static final String _label = "label";

    public static final int _labelLength = 250;

    @Type(value = SQLXMLType.class)
    @Column(name = "definition", columnDefinition = "xml")
    private String definition;

    public static final String _definition = "definition";

    @Column(name = "status", nullable = false)
    @Convert(converter = DmpBlueprintStatusConverter.class)
    private DmpBlueprintStatus status;

    public static final String _status = "status";

    @Column(name = "group_id", columnDefinition = "uuid", nullable = false)
    private UUID groupId;

    public static final String _groupId = "groupId";

    @Column(name = "version", nullable = false)
    private Short version;

    public static final String _version = "version";

    @Column(name = "version_status", nullable = false)
    @Convert(converter = DmpBlueprintVersionStatusConverter.class)
    private DmpBlueprintVersionStatus versionStatus;

    public static final String _versionStatus = "versionStatus";

    @Column(name = "created_at", nullable = false)
    private Instant createdAt = null;

    public static final String _createdAt = "createdAt";

    @Column(name = "updated_at", nullable = false)
    private Instant updatedAt;

    public static final String _updatedAt = "updatedAt";

    @Column(name = "is_active", nullable = false)
    @Convert(converter = IsActiveConverter.class)
    private IsActive isActive;

    public static final String _isActive = "isActive";

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public String getDefinition() {
        return definition;
    }

    public void setDefinition(String definition) {
        this.definition = definition;
    }

    public DmpBlueprintStatus getStatus() {
        return status;
    }

    public void setStatus(DmpBlueprintStatus status) {
        this.status = status;
    }

    public UUID getGroupId() {
        return groupId;
    }

    public void setGroupId(UUID groupId) {
        this.groupId = groupId;
    }

    public Short getVersion() {
        return version;
    }

    public void setVersion(Short version) {
        this.version = version;
    }

    public DmpBlueprintVersionStatus getVersionStatus() {
        return versionStatus;
    }

    public void setVersionStatus(DmpBlueprintVersionStatus versionStatus) {
        this.versionStatus = versionStatus;
    }

    public Instant getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Instant createdAt) {
        this.createdAt = createdAt;
    }

    public Instant getUpdatedAt() {
        return updatedAt;
    }

    public void setUpdatedAt(Instant updatedAt) {
        this.updatedAt = updatedAt;
    }

    public IsActive getIsActive() {
        return isActive;
    }

    public void setIsActive(IsActive isActive) {
        this.isActive = isActive;
    }
}
