package eu.eudat.data;

import eu.eudat.commons.enums.DmpAccessType;
import eu.eudat.commons.enums.DmpStatus;
import eu.eudat.commons.enums.DmpVersionStatus;
import eu.eudat.commons.enums.IsActive;
import eu.eudat.data.converters.enums.DmpAccessTypeNullableConverter;
import eu.eudat.data.converters.enums.DmpStatusConverter;
import eu.eudat.data.converters.enums.DmpVersionStatusConverter;
import eu.eudat.data.converters.enums.IsActiveConverter;
import eu.eudat.data.tenant.TenantScopedBaseEntity;
import jakarta.persistence.*;

import java.time.Instant;
import java.util.UUID;

@Entity
@Table(name = "\"Dmp\"")
public class DmpEntity extends TenantScopedBaseEntity {

    @Id
    @Column(name = "id", updatable = false, nullable = false, columnDefinition = "BINARY(16)")
    private UUID id;

    public static final String _id = "id";

    @Column(name = "label", length = DescriptionEntity._labelLength, nullable = false)
    private String label;

    public static final String _label = "label";
    public static final int _labelLength = 250;

    @Column(name = "version", nullable = false)
    private Short version;

    public static final String _version = "version";

    @Column(name = "version_status", nullable = false)
    @Convert(converter = DmpVersionStatusConverter.class)
    private DmpVersionStatus versionStatus;

    public static final String _versionStatus = "versionStatus";

    @Column(name = "status", nullable = false)
    @Convert(converter = DmpStatusConverter.class)
    private DmpStatus status;

    public static final String _status = "status";

    @Column(name = "properties", nullable = true)
    private String properties;

    public static final String _properties = "properties";

    @Column(name = "group_id", nullable = false)
    private UUID groupId;

    public static final String _groupId = "groupId";

    @Column(name = "description", nullable = true)
    private String description;

    public static final String _description = "description";

    @Column(name = "created_at", nullable = false)
    private Instant createdAt;

    public static final String _createdAt = "createdAt";

    @Column(name = "updated_at", nullable = false)
    private Instant updatedAt;

    public static final String _updatedAt = "updatedAt";

    @Column(name = "is_active", nullable = false)
    @Convert(converter = IsActiveConverter.class)
    private IsActive isActive;

    public static final String _isActive = "isActive";

    @Column(name = "finalized_at")
    private Instant finalizedAt;

    public static final String _finalizedAt = "finalizedAt";

    @Column(name = "creator", nullable = false)
    private UUID creatorId;

    public static final String _creatorId = "creatorId";

    @Column(name = "access_type", nullable = true)
    @Convert(converter = DmpAccessTypeNullableConverter.class)
    private DmpAccessType accessType;

    public static final String _accessType = "accessType";

    @Column(name = "blueprint", nullable = false)
    private UUID blueprintId;

    public static final String _blueprintId = "blueprintId";

    @Column(name = "language", nullable = true)
    private String language;

    public static final String _language = "language";

    @Column(name = "public_after", nullable = true)
    private Instant publicAfter;

    public static final String _publicAfter = "publicAfter";

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public Short getVersion() {
        return version;
    }

    public void setVersion(Short version) {
        this.version = version;
    }

    public DmpStatus getStatus() {
        return status;
    }

    public void setStatus(DmpStatus status) {
        this.status = status;
    }

    public String getProperties() {
        return properties;
    }

    public void setProperties(String properties) {
        this.properties = properties;
    }

    public UUID getGroupId() {
        return groupId;
    }

    public void setGroupId(UUID groupId) {
        this.groupId = groupId;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Instant getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Instant createdAt) {
        this.createdAt = createdAt;
    }

    public Instant getUpdatedAt() {
        return updatedAt;
    }

    public void setUpdatedAt(Instant updatedAt) {
        this.updatedAt = updatedAt;
    }

    public IsActive getIsActive() {
        return isActive;
    }

    public void setIsActive(IsActive isActive) {
        this.isActive = isActive;
    }

    public Instant getFinalizedAt() {
        return finalizedAt;
    }

    public void setFinalizedAt(Instant finalizedAt) {
        this.finalizedAt = finalizedAt;
    }

    public UUID getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(UUID creatorId) {
        this.creatorId = creatorId;
    }

    public DmpAccessType getAccessType() {
        return accessType;
    }

    public void setAccessType(DmpAccessType accessType) {
        this.accessType = accessType;
    }

    public UUID getBlueprintId() {
        return blueprintId;
    }

    public void setBlueprintId(UUID blueprintId) {
        this.blueprintId = blueprintId;
    }

    public String getLanguage() {
        return language;
    }

    public void setLanguage(String language) {
        this.language = language;
    }

    public Instant getPublicAfter() {
        return publicAfter;
    }

    public void setPublicAfter(Instant publicAfter) {
        this.publicAfter = publicAfter;
    }

    public DmpVersionStatus getVersionStatus() {
        return versionStatus;
    }

    public void setVersionStatus(DmpVersionStatus versionStatus) {
        this.versionStatus = versionStatus;
    }
}
