package eu.eudat.data.converters.enums;

import eu.eudat.commons.enums.DmpAccessType;
import jakarta.persistence.Converter;

@Converter
public class DmpAccessTypeNullableConverter extends DatabaseEnumConverter<DmpAccessType, Short> {

    @Override
    protected DmpAccessType of(Short i) {
        return DmpAccessType.of(i);
    }


    @Override
    public Short convertToDatabaseColumn(DmpAccessType value) {
        if (value == null)  return null;
        return value.getValue();
    }

    @Override
    public DmpAccessType convertToEntityAttribute(Short dbData) {
        return dbData == null ? null : this.of(dbData);
    }
}
