package eu.eudat.elastic.data;

import eu.eudat.commons.enums.DescriptionStatus;
import eu.eudat.elastic.data.nested.*;
import gr.cite.tools.elastic.ElasticConstants;
import org.springframework.data.annotation.Id;
import org.springframework.data.elasticsearch.annotations.*;

import java.util.Date;
import java.util.List;
import java.util.UUID;

@Document(indexName = "description")
public class DescriptionElasticEntity {
	
	@Id
	@Field(value = DescriptionElasticEntity._id, type = FieldType.Keyword)
	private UUID id;
	public final static String _id = "id";

	@Field(value = DescriptionElasticEntity._tenantId, type = FieldType.Keyword)
	private UUID tenantId;
	public final static String _tenantId = "tenantId";

	@MultiField(mainField = @Field(value = DescriptionElasticEntity._label, type = FieldType.Text), otherFields = {
			@InnerField(suffix = ElasticConstants.SubFields.keyword, type = FieldType.Keyword)
	})
	private String label;
	public final static String _label = "label";

	@Field(value = DescriptionElasticEntity._description, type = FieldType.Text)
	private String description;
	public final static String _description = "description";

	@Field(value = DescriptionElasticEntity._status, type = FieldType.Short)
	private DescriptionStatus status;
	public final static String _status = "status";

	@Field(value = DescriptionElasticEntity._finalizedAt, type = FieldType.Date)
	private Date finalizedAt;
	public final static String _finalizedAt = "finalizedAt";

	@Field(value = DescriptionElasticEntity._createdAt, type = FieldType.Date)
	private Date createdAt;
	public final static String _createdAt = "createdAt";

	@Field(value = DescriptionElasticEntity._tags, type = FieldType.Nested)
	private List<NestedTagElasticEntity> tags;
	public final static String _tags = "tags";

	@Field(value = DescriptionElasticEntity._descriptionTemplate, type = FieldType.Object)
	private NestedDescriptionTemplateElasticEntity descriptionTemplate;
	public final static String _descriptionTemplate = "descriptionTemplate";

	@Field(value = DescriptionElasticEntity._dmp, type = FieldType.Object)
	private NestedDmpElasticEntity dmp;
	public final static String _dmp = "dmp";

	@Field(value = DescriptionElasticEntity._references, type = FieldType.Nested)
	private List<NestedReferenceElasticEntity> references;
	public final static String _references = "references";

	public UUID getId() {
		return id;
	}

	public void setId(UUID id) {
		this.id = id;
	}

	public UUID getTenantId() {
		return tenantId;
	}

	public void setTenantId(UUID tenantId) {
		this.tenantId = tenantId;
	}

	public String getLabel() {
		return label;
	}

	public void setLabel(String label) {
		this.label = label;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public DescriptionStatus getStatus() {
		return status;
	}

	public void setStatus(DescriptionStatus status) {
		this.status = status;
	}

	public Date getFinalizedAt() {
		return finalizedAt;
	}

	public void setFinalizedAt(Date finalizedAt) {
		this.finalizedAt = finalizedAt;
	}

	public List<NestedTagElasticEntity> getTags() {
		return tags;
	}

	public void setTags(List<NestedTagElasticEntity> tags) {
		this.tags = tags;
	}

	public NestedDescriptionTemplateElasticEntity getDescriptionTemplate() {
		return descriptionTemplate;
	}

	public void setDescriptionTemplate(NestedDescriptionTemplateElasticEntity descriptionTemplate) {
		this.descriptionTemplate = descriptionTemplate;
	}

	public NestedDmpElasticEntity getDmp() {
		return dmp;
	}

	public void setDmp(NestedDmpElasticEntity dmp) {
		this.dmp = dmp;
	}

	public List<NestedReferenceElasticEntity> getReferences() {
		return references;
	}

	public void setReferences(List<NestedReferenceElasticEntity> references) {
		this.references = references;
	}

	public Date getCreatedAt() {
		return createdAt;
	}

	public void setCreatedAt(Date createdAt) {
		this.createdAt = createdAt;
	}
}
