package eu.eudat.elastic.data.nested;

import eu.eudat.commons.enums.DescriptionStatus;
import eu.eudat.elastic.data.DescriptionElasticEntity;
import gr.cite.tools.elastic.ElasticConstants;
import org.springframework.data.annotation.Id;
import org.springframework.data.elasticsearch.annotations.*;

import java.util.Date;
import java.util.List;
import java.util.UUID;

public class NestedDescriptionElasticEntity {
	
	@Id
	@Field(value = NestedDescriptionElasticEntity._id, type = FieldType.Keyword)
	private UUID id;
	public final static String _id = "id";

	@Field(value = NestedDescriptionElasticEntity._dmpId, type = FieldType.Keyword)
	private UUID dmpId;
	public final static String _dmpId = "dmpId";

	@MultiField(mainField = @Field(value = NestedDescriptionElasticEntity._label, type = FieldType.Text), otherFields = {
			@InnerField(suffix = ElasticConstants.SubFields.keyword, type = FieldType.Keyword)
	})
	private String label;
	public final static String _label = "label";

	@Field(value = NestedDescriptionElasticEntity._description, type = FieldType.Text)
	private String description;
	public final static String _description = "description";

	@Field(value = NestedDescriptionElasticEntity._status, type = FieldType.Short )
	private DescriptionStatus status;
	public final static String _status = "status";

	@Field(value = NestedDescriptionElasticEntity._finalizedAt, type = FieldType.Date)
	private Date finalizedAt;
	public final static String _finalizedAt = "finalizedAt";

	@Field(value = NestedDescriptionElasticEntity._tags, type = FieldType.Nested)
	private List<NestedTagElasticEntity> tags;
	public final static String _tags = "tags";

	@Field(value = NestedDescriptionElasticEntity._references, type = FieldType.Nested)
	private List<NestedReferenceElasticEntity> references;
	public final static String _references = "references";

	@Field(value = DescriptionElasticEntity._descriptionTemplate, type = FieldType.Object)
	private NestedDescriptionTemplateElasticEntity descriptionTemplate;
	public final static String _descriptionTemplate = "descriptionTemplate";

	public UUID getId() {
		return id;
	}

	public void setId(UUID id) {
		this.id = id;
	}

	public UUID getDmpId() {
		return dmpId;
	}

	public void setDmpId(UUID dmpId) {
		this.dmpId = dmpId;
	}

	public String getLabel() {
		return label;
	}

	public void setLabel(String label) {
		this.label = label;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public DescriptionStatus getStatus() {
		return status;
	}

	public void setStatus(DescriptionStatus status) {
		this.status = status;
	}

	public Date getFinalizedAt() {
		return finalizedAt;
	}

	public void setFinalizedAt(Date finalizedAt) {
		this.finalizedAt = finalizedAt;
	}

	public List<NestedTagElasticEntity> getTags() {
		return tags;
	}

	public void setTags(List<NestedTagElasticEntity> tags) {
		this.tags = tags;
	}

	public List<NestedReferenceElasticEntity> getReferences() {
		return references;
	}

	public void setReferences(List<NestedReferenceElasticEntity> references) {
		this.references = references;
	}

	public NestedDescriptionTemplateElasticEntity getDescriptionTemplate() {
		return descriptionTemplate;
	}

	public void setDescriptionTemplate(NestedDescriptionTemplateElasticEntity descriptionTemplate) {
		this.descriptionTemplate = descriptionTemplate;
	}
}
