package eu.eudat.elastic.data.nested;

import eu.eudat.commons.enums.DmpAccessType;
import eu.eudat.commons.enums.DmpStatus;
import eu.eudat.commons.enums.DmpVersionStatus;
import eu.eudat.elastic.data.DmpElasticEntity;
import gr.cite.tools.elastic.ElasticConstants;
import org.springframework.data.annotation.Id;
import org.springframework.data.elasticsearch.annotations.*;

import java.util.Date;
import java.util.List;
import java.util.UUID;

public class NestedDmpElasticEntity {
	@Id
	@Field(value = NestedDmpElasticEntity._id, type = FieldType.Keyword)
	private UUID id;
	public final static String _id = "id";

	@MultiField(mainField = @Field(value = NestedDmpElasticEntity._label, type = FieldType.Text), otherFields = {
			@InnerField(suffix = ElasticConstants.SubFields.keyword, type = FieldType.Keyword)
	})
	private String label;
	public final static String _label = "label";

	@Field(value = NestedDmpElasticEntity._description, type = FieldType.Text)
	private String description;
	public final static String _description = "description";

	@Field(value = NestedDmpElasticEntity._version, type = FieldType.Keyword)
	private Short version;
	public final static String _version = "version";
	
	@Field(value = NestedDmpElasticEntity._versionStatus, type = FieldType.Short)
	private DmpVersionStatus versionStatus;
	public final static String _versionStatus = "versionStatus";

	@Field(value = NestedDmpElasticEntity._status, type = FieldType.Short)
	private DmpStatus status;
	public final static String _status = "status";

	@Field(value = NestedDmpElasticEntity._accessType, type = FieldType.Short)
	private DmpAccessType accessType;
	public final static String _accessType = "accessType";

	@Field(value = NestedDmpElasticEntity._language, type = FieldType.Keyword)
	private String language;
	public final static String _language = "language";

	@Field(value = NestedDmpElasticEntity._blueprintId, type = FieldType.Keyword)
	private UUID blueprintId;
	public final static String _blueprintId = "blueprintId";

	@Field(value = NestedDmpElasticEntity._groupId, type = FieldType.Keyword)
	private UUID groupId;
	public final static String _groupId = "groupId";

	@Field(value = NestedDmpElasticEntity._finalizedAt, type = FieldType.Date)
	private Date finalizedAt;
	public final static String _finalizedAt = "finalizedAt";

	@Field(value = NestedDmpElasticEntity._references, type = FieldType.Nested)
	private List<NestedReferenceElasticEntity> references;
	public final static String _references = "references";

	@Field(value = NestedDmpElasticEntity._collaborators, type = FieldType.Nested)
	private List<NestedCollaboratorElasticEntity> collaborators;
	public final static String _collaborators = "collaborators";

	@Field(value = NestedDmpElasticEntity._dois, type = FieldType.Nested)
	private List<NestedDoiElasticEntity> dois;
	public final static String _dois = "dois";

	public UUID getId() {
		return id;
	}

	public void setId(UUID id) {
		this.id = id;
	}

	public String getLabel() {
		return label;
	}

	public void setLabel(String label) {
		this.label = label;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public Short getVersion() {
		return version;
	}

	public void setVersion(Short version) {
		this.version = version;
	}

	public DmpStatus getStatus() {
		return status;
	}

	public void setStatus(DmpStatus status) {
		this.status = status;
	}

	public DmpAccessType getAccessType() {
		return accessType;
	}

	public void setAccessType(DmpAccessType accessType) {
		this.accessType = accessType;
	}

	public String getLanguage() {
		return language;
	}

	public void setLanguage(String language) {
		this.language = language;
	}

	public UUID getBlueprintId() {
		return blueprintId;
	}

	public void setBlueprintId(UUID blueprintId) {
		this.blueprintId = blueprintId;
	}

	public UUID getGroupId() {
		return groupId;
	}

	public void setGroupId(UUID groupId) {
		this.groupId = groupId;
	}

	public Date getFinalizedAt() {
		return finalizedAt;
	}

	public void setFinalizedAt(Date finalizedAt) {
		this.finalizedAt = finalizedAt;
	}

	public List<NestedReferenceElasticEntity> getReferences() {
		return references;
	}

	public void setReferences(List<NestedReferenceElasticEntity> references) {
		this.references = references;
	}

	public List<NestedCollaboratorElasticEntity> getCollaborators() {
		return collaborators;
	}

	public void setCollaborators(List<NestedCollaboratorElasticEntity> collaborators) {
		this.collaborators = collaborators;
	}

	public List<NestedDoiElasticEntity> getDois() {
		return dois;
	}

	public void setDois(List<NestedDoiElasticEntity> dois) {
		this.dois = dois;
	}

	public DmpVersionStatus getVersionStatus() {
		return versionStatus;
	}

	public void setVersionStatus(DmpVersionStatus versionStatus) {
		this.versionStatus = versionStatus;
	}
}
