package eu.eudat.integrationevent.outbox;

import org.springframework.boot.context.properties.ConfigurationProperties;

@ConfigurationProperties(prefix = "queue.task.publisher.options")
public class OutboxProperties {

	private final String exchange;

	private final String tenantTouchTopic;

	private final String tenantRemovalTopic;

	private final String tenantReactivationTopic;

	private final String tenantUserInviteTopic;

	private final String userRemovalTopic;

	private final String userTouchTopic;

	private final String dmpTouchTopic;

	private final String descriptionTouchTopic;

	private final String annotationEntitiesTouchTopic;
	private final String annotationEntitiesRemovalTopic;

	private final String notifyTopic;

	private final String forgetMeCompletedTopic;

	private final String whatYouKnowAboutMeCompletedTopic;

	private final String generateFileTopic;

	public OutboxProperties(String exchange,
	                        String tenantTouchTopic,
	                        String tenantRemovalTopic,
	                        String tenantReactivationTopic,
	                        String tenantUserInviteTopic,
	                        String userRemovalTopic,
	                        String userTouchTopic,
	                        String dmpTouchTopic,
	                        String descriptionTouchTopic,
	                        String annotationEntitiesTouchTopic, 
	                        String annotationEntitiesRemovalTopic,
	                        String notifyTopic,
	                        String forgetMeCompletedTopic,
	                        String whatYouKnowAboutMeCompletedTopic,
	                        String generateFileTopic
	) {
		this.exchange = exchange;
		this.tenantTouchTopic = tenantTouchTopic;
		this.tenantRemovalTopic = tenantRemovalTopic;
		this.tenantReactivationTopic = tenantReactivationTopic;
		this.tenantUserInviteTopic = tenantUserInviteTopic;
        this.userRemovalTopic = userRemovalTopic;
        this.userTouchTopic = userTouchTopic;
        this.dmpTouchTopic = dmpTouchTopic;
        this.descriptionTouchTopic = descriptionTouchTopic;
        this.annotationEntitiesTouchTopic = annotationEntitiesTouchTopic;
		this.annotationEntitiesRemovalTopic = annotationEntitiesRemovalTopic;
		this.notifyTopic = notifyTopic;
		this.forgetMeCompletedTopic = forgetMeCompletedTopic;
		this.whatYouKnowAboutMeCompletedTopic = whatYouKnowAboutMeCompletedTopic;
		this.generateFileTopic = generateFileTopic;
	}

	public String getExchange() {
		return exchange;
	}

	public String getTenantTouchTopic() {
		return tenantTouchTopic;
	}

	public String getTenantRemovalTopic() {
		return tenantRemovalTopic;
	}

	public String getTenantReactivationTopic() {
		return tenantReactivationTopic;
	}

	public String getTenantUserInviteTopic() {
		return tenantUserInviteTopic;
	}

	public String getUserRemovalTopic() {
		return userRemovalTopic;
	}

	public String getUserTouchTopic() {
		return userTouchTopic;
	}

	public String getDmpTouchTopic() {
		return dmpTouchTopic;
	}

	public String getDescriptionTouchTopic() {
		return descriptionTouchTopic;
	}

	public String getAnnotationEntitiesTouchTopic() {
		return annotationEntitiesTouchTopic;
	}

	public String getAnnotationEntitiesRemovalTopic() {
		return annotationEntitiesRemovalTopic;
	}

	public String getNotifyTopic() {
		return notifyTopic;
	}

	public String getForgetMeCompletedTopic() {
		return forgetMeCompletedTopic;
	}

	public String getWhatYouKnowAboutMeCompletedTopic() {
		return whatYouKnowAboutMeCompletedTopic;
	}

	public String getGenerateFileTopic() {
		return generateFileTopic;
	}
}
