package eu.eudat.integrationevent.outbox.tenantremoval;

import eu.eudat.integrationevent.inbox.ConsistencyHandler;
import eu.eudat.query.TenantQuery;
import gr.cite.tools.data.query.QueryFactory;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component
@Scope(value = ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class TenantRemovalConsistencyHandler implements ConsistencyHandler<TenantRemovalConsistencyPredicates> {

    private final QueryFactory queryFactory;

    public TenantRemovalConsistencyHandler(QueryFactory queryFactory) {
        this.queryFactory = queryFactory;
    }

    @Override
    public Boolean isConsistent(TenantRemovalConsistencyPredicates consistencyPredicates) {
        long count = this.queryFactory.query(TenantQuery.class).ids(consistencyPredicates.getTenantId()).count();
        return count > 0;
    }

}
