package eu.eudat.model;

import eu.eudat.commons.enums.DmpAccessType;
import eu.eudat.commons.enums.DmpStatus;
import eu.eudat.commons.enums.DmpVersionStatus;
import eu.eudat.commons.enums.IsActive;
import eu.eudat.model.dmpproperties.DmpProperties;

import java.time.Instant;
import java.util.List;
import java.util.UUID;

public class Dmp {

    private UUID id;
    public static final String _id = "id";

    private String label;
    public static final String _label = "label";

    private Short version;
    public static final String _version = "version";

    private DmpStatus status;
    public static final String _status = "status";
    
    private DmpVersionStatus versionStatus;
    public static final String _versionStatus = "versionStatus";

    private DmpProperties properties;
    public static final String _properties = "properties";

    private UUID groupId;
    public static final String _groupId = "groupId";

    private String description;
    public static final String _description = "description";

    private Instant createdAt;
    public static final String _createdAt = "createdAt";

    private Instant updatedAt;
    public static final String _updatedAt = "updatedAt";

    private IsActive isActive;
    public static final String _isActive = "isActive";

    private Instant finalizedAt;
    public static final String _finalizedAt = "finalizedAt";

    private Instant publishedAt;
    public static final String _publishedAt = "publishedAt";

    private User creator;
    public static final String _creator = "creator";

    private DmpAccessType accessType;
    public static final String _accessType = "accessType";

    private DmpBlueprint blueprint;
    public static final String _blueprint = "blueprint";

    private String language;
    public static final String _language = "language";

    private Instant publicAfter;
    public static final String _publicAfter = "publicAfter";

    private String hash;
    public static final String _hash = "hash";

    private List<DmpReference> dmpReferences;
    public static final String _dmpReferences = "dmpReferences";

    private List<DmpUser> dmpUsers;
    public static final String _dmpUsers = "dmpUsers";

    private List<Description> descriptions;
    public static final String _descriptions = "descriptions";

    private List<DmpDescriptionTemplate> dmpDescriptionTemplates;
    public static final String _dmpDescriptionTemplates = "dmpDescriptionTemplates";

    private List<EntityDoi> entityDois;
    public static final String _entityDois = "entityDois";

    private List<String> authorizationFlags;
    public static final String _authorizationFlags = "authorizationFlags";


    private Boolean belongsToCurrentTenant;
    public static final String _belongsToCurrentTenant = "belongsToCurrentTenant";

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public Short getVersion() {
        return version;
    }

    public void setVersion(Short version) {
        this.version = version;
    }

    public DmpStatus getStatus() {
        return status;
    }

    public void setStatus(DmpStatus status) {
        this.status = status;
    }

    public DmpProperties getProperties() {
        return properties;
    }

    public void setProperties(DmpProperties properties) {
        this.properties = properties;
    }

    public UUID getGroupId() {
        return groupId;
    }

    public void setGroupId(UUID groupId) {
        this.groupId = groupId;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Instant getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Instant createdAt) {
        this.createdAt = createdAt;
    }

    public Instant getUpdatedAt() {
        return updatedAt;
    }

    public void setUpdatedAt(Instant updatedAt) {
        this.updatedAt = updatedAt;
    }

    public IsActive getIsActive() {
        return isActive;
    }

    public void setIsActive(IsActive isActive) {
        this.isActive = isActive;
    }

    public Instant getFinalizedAt() {
        return finalizedAt;
    }

    public void setFinalizedAt(Instant finalizedAt) {
        this.finalizedAt = finalizedAt;
    }

    public Instant getPublishedAt() {
        return publishedAt;
    }

    public void setPublishedAt(Instant publishedAt) {
        this.publishedAt = publishedAt;
    }

    public User getCreator() {
        return creator;
    }

    public void setCreator(User creator) {
        this.creator = creator;
    }

    public DmpAccessType getAccessType() {
        return accessType;
    }

    public void setAccessType(DmpAccessType accessType) {
        this.accessType = accessType;
    }

    public DmpBlueprint getBlueprint() {
        return blueprint;
    }

    public void setBlueprint(DmpBlueprint blueprint) {
        this.blueprint = blueprint;
    }

    public String getLanguage() {
        return language;
    }

    public void setLanguage(String language) {
        this.language = language;
    }

    public Instant getPublicAfter() {
        return publicAfter;
    }

    public void setPublicAfter(Instant publicAfter) {
        this.publicAfter = publicAfter;
    }

    public String getHash() {
        return hash;
    }

    public void setHash(String hash) {
        this.hash = hash;
    }

    public List<DmpReference> getDmpReferences() {
        return dmpReferences;
    }

    public void setDmpReferences(List<DmpReference> dmpReferences) {
        this.dmpReferences = dmpReferences;
    }

    public List<DmpUser> getDmpUsers() {
        return dmpUsers;
    }

    public void setDmpUsers(List<DmpUser> dmpUsers) {
        this.dmpUsers = dmpUsers;
    }

    public DmpVersionStatus getVersionStatus() {
        return versionStatus;
    }

    public void setVersionStatus(DmpVersionStatus versionStatus) {
        this.versionStatus = versionStatus;
    }

    public List<Description> getDescriptions() {
        return descriptions;
    }

    public void setDescriptions(List<Description> descriptions) {
        this.descriptions = descriptions;
    }

    public List<DmpDescriptionTemplate> getDmpDescriptionTemplates() {
        return dmpDescriptionTemplates;
    }

    public void setDmpDescriptionTemplates(List<DmpDescriptionTemplate> dmpDescriptionTemplates) {
        this.dmpDescriptionTemplates = dmpDescriptionTemplates;
    }

    public List<EntityDoi> getEntityDois() {
        return entityDois;
    }

    public void setEntityDois(List<EntityDoi> entityDois) {
        this.entityDois = entityDois;
    }

    public List<String> getAuthorizationFlags() {
        return authorizationFlags;
    }

    public void setAuthorizationFlags(List<String> authorizationFlags) {
        this.authorizationFlags = authorizationFlags;
    }

    public Boolean getBelongsToCurrentTenant() {
        return belongsToCurrentTenant;
    }

    public void setBelongsToCurrentTenant(Boolean belongsToCurrentTenant) {
        this.belongsToCurrentTenant = belongsToCurrentTenant;
    }
}
