package eu.eudat.model.builder.commonmodels.descriptiontemplate.fielddata;

import eu.eudat.commonmodels.models.descriptiotemplate.fielddata.ReferenceTypeDataModel;
import eu.eudat.commons.types.descriptiontemplate.fielddata.ReferenceTypeDataEntity;
import eu.eudat.convention.ConventionService;
import eu.eudat.model.builder.ReferenceTypeBuilder;
import eu.eudat.model.builder.commonmodels.ReferenceTypeCommonModelBuilder;
import eu.eudat.query.ReferenceTypeQuery;
import gr.cite.tools.data.builder.BuilderFactory;
import gr.cite.tools.data.query.QueryFactory;
import gr.cite.tools.logging.LoggerService;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component
@Scope(value = ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class ReferenceTypeDataCommonModelBuilder extends BaseFieldDataCommonModelBuilder<ReferenceTypeDataModel, ReferenceTypeDataEntity> {

    private final QueryFactory queryFactory;
    private final BuilderFactory builderFactory;
    @Autowired
    public ReferenceTypeDataCommonModelBuilder(
		    ConventionService conventionService, QueryFactory queryFactory, BuilderFactory builderFactory
    ) {
        super(conventionService, new LoggerService(LoggerFactory.getLogger(ReferenceTypeDataCommonModelBuilder.class)));
	    this.queryFactory = queryFactory;
	    this.builderFactory = builderFactory;
    }

    protected ReferenceTypeDataModel getInstance() {
        return new ReferenceTypeDataModel();
    }

    @Override
    protected void buildChild(ReferenceTypeDataEntity d, ReferenceTypeDataModel m) {
        m.setMultipleSelect(d.getMultipleSelect());
        if (d.getReferenceTypeId() != null) m.setReferenceType(this.builderFactory.builder(ReferenceTypeCommonModelBuilder.class).build(this.queryFactory.query(ReferenceTypeQuery.class).ids(d.getReferenceTypeId()).first())); //TODO: Optimize
        
    }
}
