package eu.eudat.model.builder.commonmodels.dmpblueprint;

import eu.eudat.commonmodels.enums.DmpBlueprintExtraFieldDataType;
import eu.eudat.commonmodels.models.dmpblueprint.ExtraFieldModel;
import eu.eudat.commons.types.dmpblueprint.ExtraFieldEntity;
import eu.eudat.convention.ConventionService;
import eu.eudat.model.dmpblueprintdefinition.ExtraField;
import gr.cite.tools.exception.MyApplicationException;
import gr.cite.tools.fieldset.FieldSet;
import gr.cite.tools.logging.LoggerService;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component
@Scope(value = ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class ExtraFieldCommonModelBuilder extends FieldCommonModelBuilder<ExtraFieldModel, ExtraFieldEntity> {

	@Autowired
	public ExtraFieldCommonModelBuilder(
			ConventionService conventionService) {
		super(conventionService);
	}

	protected ExtraFieldModel getInstance() {
		return new ExtraFieldModel();
	}

	protected ExtraFieldModel buildChild(ExtraFieldEntity data, ExtraFieldModel model) {
		switch (data.getType()){
			case Date -> model.setDataType(DmpBlueprintExtraFieldDataType.Date);
			case Number -> model.setDataType(DmpBlueprintExtraFieldDataType.Number);
			case RichTex -> model.setDataType(DmpBlueprintExtraFieldDataType.RichTex);
			case Text -> model.setDataType(DmpBlueprintExtraFieldDataType.Text);
			default -> throw new MyApplicationException("unrecognized type " + data.getType());
		}
		return model;
	}
}
