package eu.eudat.model.builder.dmpblueprintdefinition;

import eu.eudat.commons.types.dmpblueprint.SystemFieldEntity;
import eu.eudat.convention.ConventionService;
import eu.eudat.model.dmpblueprintdefinition.SystemField;
import gr.cite.tools.fieldset.FieldSet;
import gr.cite.tools.logging.LoggerService;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component
@Scope(value = ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class SystemFieldBuilder extends FieldBuilder<SystemField, SystemFieldEntity> {

	@Autowired
	public SystemFieldBuilder(
			ConventionService conventionService) {
		super(conventionService, new LoggerService(LoggerFactory.getLogger(SystemFieldBuilder.class)));
	}

	protected SystemField getInstance() {
		return new SystemField();
	}

	protected SystemField buildChild(FieldSet fields, SystemFieldEntity data, SystemField model) {
		if (fields.hasField(this.asIndexer(SystemField._systemFieldType))) model.setSystemFieldType(data.getType());
		return model;
	}
}
