package eu.eudat.model.mapper.publicapi;

import eu.eudat.model.descriptiontemplatedefinition.Page;
import eu.eudat.model.publicapi.datasetwizard.DatasetProfilePage;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class DescriptionPageToDatasetPageMapper {

    private final DescriptionSectionToDatasetSectionMapper descriptionSectionToDatasetSectionMapper;

    public DescriptionPageToDatasetPageMapper(DescriptionSectionToDatasetSectionMapper descriptionSectionToDatasetSectionMapper) {
        this.descriptionSectionToDatasetSectionMapper = descriptionSectionToDatasetSectionMapper;
    }

    public DatasetProfilePage toPublicModel(Page page) {
        DatasetProfilePage model = new DatasetProfilePage();
        model.setOrdinal(page.getOrdinal());
        model.setTitle(page.getTitle());
        if (page.getSections() != null) model.setSections(page.getSections().stream().map(x-> descriptionSectionToDatasetSectionMapper.toPublicModel(x, page.getOrdinal())).toList());
        return model;
    }
}
