package eu.eudat.model.persist.descriptiontemplatedefinition;

import eu.eudat.commons.validation.BaseValidator;
import gr.cite.tools.validation.ValidatorFactory;
import gr.cite.tools.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.stereotype.Component;

import java.util.Arrays;
import java.util.List;

public class FieldSetPersist {

    private String id = null;

    public static final String _id = "id";

    private Integer ordinal = null;

    public static final String _ordinal = "ordinal";

    private String numbering = null;

    public static final String _numbering = "numbering";

    private String title = null;

    public static final String _title = "title";

    private String description = null;

    public static final String _description = "description";

    private String extendedDescription = null;
    public static final String _extendedDescription = "extendedDescription";

    private String additionalInformation = null;
    public static final String _additionalInformation = "additionalInformation";

    private MultiplicityPersist multiplicity = null;
    public static final String _multiplicity = "multiplicity";

    private Boolean hasCommentField = null;

    private List<FieldPersist> fields = null;

    public static final String _fields = "fields";

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public Integer getOrdinal() {
        return ordinal;
    }

    public void setOrdinal(Integer ordinal) {
        this.ordinal = ordinal;
    }

    public String getNumbering() {
        return numbering;
    }

    public void setNumbering(String numbering) {
        this.numbering = numbering;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getExtendedDescription() {
        return extendedDescription;
    }

    public void setExtendedDescription(String extendedDescription) {
        this.extendedDescription = extendedDescription;
    }

    public String getAdditionalInformation() {
        return additionalInformation;
    }

    public void setAdditionalInformation(String additionalInformation) {
        this.additionalInformation = additionalInformation;
    }

    public MultiplicityPersist getMultiplicity() {
        return multiplicity;
    }

    public void setMultiplicity(MultiplicityPersist multiplicity) {
        this.multiplicity = multiplicity;
    }

    public Boolean getHasCommentField() {
        return hasCommentField;
    }

    public void setHasCommentField(Boolean hasCommentField) {
        this.hasCommentField = hasCommentField;
    }

    public List<FieldPersist> getFields() {
        return fields;
    }

    public void setFields(List<FieldPersist> fields) {
        this.fields = fields;
    }

    @Component(FieldSetPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class FieldSetPersistValidator extends BaseValidator<FieldSetPersist> {

        public static final String ValidatorName = "DescriptionTemplate.FieldSetPersistValidator";

        private final MessageSource messageSource;

        private final ValidatorFactory validatorFactory;

        protected FieldSetPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource, ValidatorFactory validatorFactory) {
            super(conventionService, errors);
            this.messageSource = messageSource;
            this.validatorFactory = validatorFactory;
        }

        @Override
        protected Class<FieldSetPersist> modelClass() {
            return FieldSetPersist.class;
        }

        @Override
        protected List<Specification> specifications(FieldSetPersist item) {
            return Arrays.asList(
                    this.spec()
                            .must(() -> !this.isEmpty(item.getId()))
                            .failOn(FieldSetPersist._id).failWith(messageSource.getMessage("Validation_Required", new Object[]{FieldSetPersist._id}, LocaleContextHolder.getLocale())),
                    this.spec()
                            .must(() -> !this.isNull(item.getOrdinal()))
                            .failOn(FieldSetPersist._ordinal).failWith(messageSource.getMessage("Validation_Required", new Object[]{FieldSetPersist._ordinal}, LocaleContextHolder.getLocale())),
                    this.spec()
                            .must(() -> !this.isEmpty(item.getNumbering()))
                            .failOn(FieldSetPersist._numbering).failWith(messageSource.getMessage("Validation_Required", new Object[]{FieldSetPersist._numbering}, LocaleContextHolder.getLocale())),
                    this.spec()
                            .must(() -> !this.isEmpty(item.getTitle()))
                            .failOn(FieldSetPersist._title).failWith(messageSource.getMessage("Validation_Required", new Object[]{FieldSetPersist._title}, LocaleContextHolder.getLocale())),
                    this.refSpec()
                            .iff(() -> !this.isNull(item.getMultiplicity()))
                            .on(FieldSetPersist._multiplicity)
                            .over(item.getMultiplicity())
                            .using(() -> this.validatorFactory.validator(MultiplicityPersist.MultiplicityValidator.class)),
                    this.navSpec()
                            .iff(() -> !this.isListNullOrEmpty(item.getFields()))
                            .on(FieldSetPersist._fields)
                            .over(item.getFields())
                            .using((itm) -> this.validatorFactory.validator(FieldPersist.FieldPersistValidator.class))
            );
        }
    }

}
