package eu.eudat.model.persist.dmpreference;

import eu.eudat.commons.validation.BaseValidator;
import gr.cite.tools.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import eu.eudat.model.persist.ReferencePersist;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.stereotype.Component;

import java.util.Arrays;
import java.util.List;
import java.util.UUID;

public class DmpReferenceDataPersist {

    private UUID blueprintFieldId;

    public static final String _blueprintFieldId = "blueprintFieldId";

    public UUID getBlueprintFieldId() {
        return blueprintFieldId;
    }

    public void setBlueprintFieldId(UUID blueprintFieldId) {
        this.blueprintFieldId = blueprintFieldId;
    }

    @Component(DmpReferenceDataPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class DmpReferenceDataPersistValidator extends BaseValidator<DmpReferenceDataPersist> {

        public static final String ValidatorName = "DmpReferenceDataPersistValidator";
        private final MessageSource messageSource;

        protected DmpReferenceDataPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource) {
            super(conventionService, errors);
	        this.messageSource = messageSource;
        }

        @Override
        protected Class<DmpReferenceDataPersist> modelClass() {
            return DmpReferenceDataPersist.class;
        }

        @Override
        protected List<Specification> specifications(DmpReferenceDataPersist item) {
            return Arrays.asList(
                    this.spec()
                            .must(() -> !this.isNull(item.getBlueprintFieldId()))
                            .failOn(DmpReferenceDataPersist._blueprintFieldId).failWith(messageSource.getMessage("Validation_Required", new Object[]{DmpReferenceDataPersist._blueprintFieldId}, LocaleContextHolder.getLocale()))
            );
        }
    }

}
