package eu.eudat.query.lookup;

import eu.eudat.commons.enums.DescriptionTemplateStatus;
import eu.eudat.commons.enums.DescriptionTemplateVersionStatus;
import eu.eudat.commons.enums.IsActive;
import eu.eudat.query.DescriptionTemplateQuery;
import gr.cite.tools.data.query.Lookup;
import gr.cite.tools.data.query.QueryFactory;

import java.util.List;
import java.util.UUID;

public class DescriptionTemplateLookup extends Lookup {

    private String like;

    private List<IsActive> isActive;

    private List<UUID> groupIds;

    private List<Short> versions;

    private List<DescriptionTemplateStatus> statuses;

    private List<DescriptionTemplateVersionStatus> versionStatuses;

    private List<UUID> ids;

    private List<UUID> typeIds;

    private List<UUID> excludedIds;

    private List<UUID> excludedGroupIds;

    public String getLike() {
        return like;
    }

    public void setLike(String like) {
        this.like = like;
    }

    public List<IsActive> getIsActive() {
        return isActive;
    }

    public void setIsActive(List<IsActive> isActive) {
        this.isActive = isActive;
    }

    public List<UUID> getGroupIds() {
        return groupIds;
    }

    public void setGroupIds(List<UUID> groupIds) {
        this.groupIds = groupIds;
    }

    public List<Short> getVersions() {
        return versions;
    }

    public void setVersions(List<Short> versions) {
        this.versions = versions;
    }

    public List<DescriptionTemplateStatus> getStatuses() {
        return statuses;
    }

    public void setStatuses(List<DescriptionTemplateStatus> statuses) {
        this.statuses = statuses;
    }

    public List<DescriptionTemplateVersionStatus> getVersionStatuses() {
        return versionStatuses;
    }

    public void setVersionStatuses(List<DescriptionTemplateVersionStatus> versionStatuses) {
        this.versionStatuses = versionStatuses;
    }

    public List<UUID> getIds() {
        return ids;
    }

    public void setIds(List<UUID> ids) {
        this.ids = ids;
    }

    public List<UUID> getTypeIds() {
        return typeIds;
    }

    public void setTypeIds(List<UUID> typeIds) {
        this.typeIds = typeIds;
    }

    public List<UUID> getExcludedIds() {
        return excludedIds;
    }

    public void setExcludedIds(List<UUID> excludedIds) {
        this.excludedIds = excludedIds;
    }

    public List<UUID> getExcludedGroupIds() {
        return excludedGroupIds;
    }

    public void setExcludedGroupIds(List<UUID> excludedGroupIds) {
        this.excludedGroupIds = excludedGroupIds;
    }

    public DescriptionTemplateQuery enrich(QueryFactory queryFactory) {
        DescriptionTemplateQuery query = queryFactory.query(DescriptionTemplateQuery.class);
        if (this.like != null)
            query.like(this.like);
        if (this.isActive != null)
            query.isActive(this.isActive);
        if (this.groupIds != null)
            query.groupIds(this.groupIds);
        if (this.statuses != null)
            query.statuses(this.statuses);
        if (this.ids != null)
            query.ids(this.ids);
        if (this.excludedIds != null)
            query.excludedIds(this.excludedIds);
        if (this.excludedGroupIds != null)
            query.excludedGroupIds(this.excludedGroupIds);
        if (this.typeIds != null)
            query.typeIds(this.typeIds);
        if (this.versions != null)
            query.versions(this.versions);
        if (this.versionStatuses != null)
            query.versionStatuses(this.versionStatuses);

        this.enrichCommon(query);

        return query;
    }

}
