package eu.eudat.query.lookup;

import eu.eudat.commons.enums.DescriptionStatus;
import eu.eudat.commons.enums.IsActive;
import eu.eudat.query.DescriptionQuery;
import eu.eudat.query.DmpDescriptionTemplateQuery;
import gr.cite.tools.data.query.Lookup;
import gr.cite.tools.data.query.QueryFactory;

import java.util.List;
import java.util.UUID;

public class DmpDescriptionTemplateLookup extends Lookup {

    private List<UUID> ids;
    private List<UUID> dmpIds;
    private List<UUID> descriptionTemplateGroupIds;
    private List<UUID> sectionIds;

    private List<UUID> excludedIds;

    private List<IsActive> isActive;

    public List<UUID> getIds() {
        return ids;
    }

    public void setIds(List<UUID> ids) {
        this.ids = ids;
    }

    public List<UUID> getExcludedIds() {
        return excludedIds;
    }

    public void setExcludedIds(List<UUID> excludedIds) {
        this.excludedIds = excludedIds;
    }

    public List<IsActive> getIsActive() {
        return isActive;
    }

    public void setIsActive(List<IsActive> isActive) {
        this.isActive = isActive;
    }

    public List<UUID> getDmpIds() {
        return dmpIds;
    }

    public void setDmpIds(List<UUID> dmpIds) {
        this.dmpIds = dmpIds;
    }

    public List<UUID> getDescriptionTemplateGroupIds() {
        return descriptionTemplateGroupIds;
    }

    public List<UUID> getSectionIds() {
        return sectionIds;
    }

    public void setSectionIds(List<UUID> sectionIds) {
        this.sectionIds = sectionIds;
    }

    public void setDescriptionTemplateGroupIds(List<UUID> descriptionTemplateGroupIds) {
        this.descriptionTemplateGroupIds = descriptionTemplateGroupIds;
    }

    public DmpDescriptionTemplateQuery enrich(QueryFactory queryFactory) {
        DmpDescriptionTemplateQuery query = queryFactory.query(DmpDescriptionTemplateQuery.class);
        if (this.ids != null) query.ids(this.ids);
        if (this.dmpIds != null) query.ids(this.dmpIds);
        if (this.descriptionTemplateGroupIds != null) query.descriptionTemplateGroupIds(this.descriptionTemplateGroupIds);
        if (this.sectionIds != null) query.sectionIds(this.sectionIds);
        if (this.excludedIds != null) query.excludedIds(this.excludedIds);
        if (this.isActive != null) query.isActive(this.isActive);

        this.enrichCommon(query);

        return query;
    }

}
