package eu.eudat.query.lookup;

import eu.eudat.query.DmpReferenceQuery;
import gr.cite.tools.data.query.Lookup;
import gr.cite.tools.data.query.QueryFactory;

import java.util.Collection;
import java.util.List;
import java.util.UUID;

public class DmpReferenceLookup extends Lookup {

    private List<UUID> ids;

    private List<UUID> dmpIds;

    private List<UUID> referenceIds;

    public List<UUID> getIds() {
        return ids;
    }

    public void setIds(List<UUID> ids) {
        this.ids = ids;
    }

    public List<UUID> getDmpIds() {
        return dmpIds;
    }

    public void setDmpIds(List<UUID> dmpIds) {
        this.dmpIds = dmpIds;
    }

    public List<UUID> getReferenceIds() {
        return referenceIds;
    }

    public void setReferenceIds(List<UUID> referenceIds) {
        this.referenceIds = referenceIds;
    }

    public DmpReferenceQuery enrich(QueryFactory queryFactory) {
        DmpReferenceQuery query = queryFactory.query(DmpReferenceQuery.class);
        if (this.ids != null) query.ids(this.ids);
        if (this.dmpIds != null) query.dmpIds(this.dmpIds);
        if (this.referenceIds != null) query.referenceIds(this.referenceIds);

        this.enrichCommon(query);

        return query;
    }

}
