package eu.eudat.query.lookup;

import eu.eudat.commons.enums.*;
import eu.eudat.elastic.query.DmpElasticQuery;
import eu.eudat.elastic.query.InnerObjectDmpElasticQuery;
import eu.eudat.elastic.query.NestedCollaboratorElasticQuery;
import eu.eudat.query.DmpUserQuery;
import gr.cite.tools.data.query.Lookup;
import gr.cite.tools.data.query.QueryFactory;

import java.util.List;
import java.util.UUID;

public class DmpUserLookup extends Lookup {


    private List<UUID> ids;

    private List<UUID> dmpIds;
    private List<UUID> userIds;
    private List<UUID> sectionIds;

    private List<IsActive> isActive;
    private List<DmpUserRole> userRoles;

    public List<UUID> getIds() {
        return ids;
    }

    public void setIds(List<UUID> ids) {
        this.ids = ids;
    }

    public List<UUID> getDmpIds() {
        return dmpIds;
    }

    public void setDmpIds(List<UUID> dmpIds) {
        this.dmpIds = dmpIds;
    }

    public List<UUID> getUserIds() {
        return userIds;
    }

    public void setUserIds(List<UUID> userIds) {
        this.userIds = userIds;
    }

    public List<UUID> getSectionIds() {
        return sectionIds;
    }

    public void setSectionIds(List<UUID> sectionIds) {
        this.sectionIds = sectionIds;
    }

    public List<IsActive> getIsActive() {
        return isActive;
    }

    public void setIsActive(List<IsActive> isActive) {
        this.isActive = isActive;
    }

    public List<DmpUserRole> getUserRoles() {
        return userRoles;
    }

    public void setUserRoles(List<DmpUserRole> userRoles) {
        this.userRoles = userRoles;
    }

    public DmpUserQuery enrich(QueryFactory queryFactory) {
        DmpUserQuery query = queryFactory.query(DmpUserQuery.class);
        if (this.ids != null) query.ids(this.ids);
        if (this.dmpIds != null) query.dmpIds(this.dmpIds);
        if (this.userIds != null) query.userIds(this.userIds);
        if (this.userRoles != null) query.userRoles(this.userRoles);
        if (this.sectionIds != null) query.sectionIds(this.sectionIds);
        if (this.isActive != null) query.isActives(this.isActive);

        this.enrichCommon(query);

        return query;
    }

    public NestedCollaboratorElasticQuery enrichElastic(QueryFactory queryFactory) {
        NestedCollaboratorElasticQuery query = queryFactory.query(NestedCollaboratorElasticQuery.class);
        if (this.ids != null) query.ids(this.ids);
        if (this.userRoles != null) query.userRoles(this.userRoles);

        this.enrichCommon(query);

        return query;
    }
}
