package eu.eudat.query.utils;

import jakarta.persistence.criteria.*;

import java.util.UUID;

public interface QueryUtilsService {
    <Key, D> Subquery<Key> buildSubQuery(BuildSubQueryInput<D, Key> parameters);

    Subquery<UUID> buildDmpAuthZSubQuery(AbstractQuery<?> query, CriteriaBuilder criteriaBuilder, UUID userId, Boolean usePublic);

    Subquery<UUID> buildDescriptionAuthZSubQuery(AbstractQuery<?> query, CriteriaBuilder criteriaBuilder, UUID userId, Boolean usePublic);

    Subquery<UUID> buildPublicDmpAuthZSubQuery(AbstractQuery<?> query,
                                               CriteriaBuilder criteriaBuilder,
                                               Boolean usePublic);

    Subquery<UUID> buildDmpUserAuthZSubQuery(AbstractQuery<?> query,
                                             CriteriaBuilder criteriaBuilder,
                                             UUID userId);

	Predicate ilike(CriteriaBuilder criteriaBuilder, Expression<String> path, String value);
}
