package eu.eudat.service.deposit;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.boot.context.properties.bind.ConstructorBinding;

import java.util.List;

@ConfigurationProperties(prefix = "deposit")
public class DepositProperties {

    private List<DepositSource> sources;

    public List<DepositSource> getSources() {
        return sources;
    }

    public void setSources(List<DepositSource> sources) {
        this.sources = sources;
    }

    public static class DepositSource {

        private String repositoryId;
        private String url;
        private String issuerUrl;
        private String clientId;
        private String clientSecret;
        private String scope;
        private String pdfTransformerId;
        private String rdaTransformerId;

        public String getRepositoryId() {
            return repositoryId;
        }

        public void setRepositoryId(String repositoryId) {
            this.repositoryId = repositoryId;
        }

        public String getUrl() {
            return url;
        }

        public void setUrl(String url) {
            this.url = url;
        }

        public String getIssuerUrl() {
            return issuerUrl;
        }

        public void setIssuerUrl(String issuerUrl) {
            this.issuerUrl = issuerUrl;
        }

        public String getClientId() {
            return clientId;
        }

        public void setClientId(String clientId) {
            this.clientId = clientId;
        }

        public String getClientSecret() {
            return clientSecret;
        }

        public void setClientSecret(String clientSecret) {
            this.clientSecret = clientSecret;
        }

        public String getScope() {
            return scope;
        }

        public void setScope(String scope) {
            this.scope = scope;
        }

        public String getPdfTransformerId() {
            return pdfTransformerId;
        }

        public void setPdfTransformerId(String pdfTransformerId) {
            this.pdfTransformerId = pdfTransformerId;
        }

        public String getRdaTransformerId() {
            return rdaTransformerId;
        }

        public void setRdaTransformerId(String rdaTransformerId) {
            this.rdaTransformerId = rdaTransformerId;
        }
    }
}
