package eu.eudat.service.elastic;

import eu.eudat.authorization.AuthorizationFlags;
import eu.eudat.model.*;
import eu.eudat.model.result.QueryResult;
import eu.eudat.query.lookup.DescriptionLookup;
import eu.eudat.query.lookup.DmpLookup;
import gr.cite.tools.fieldset.FieldSet;

import java.util.EnumSet;


public interface ElasticQueryHelperService {
    QueryResult<Dmp> collect(DmpLookup lookup, EnumSet<AuthorizationFlags> authorizationFlags, FieldSet fieldSet);
    QueryResult<PublicDmp> collectPublic(DmpLookup lookup, EnumSet<AuthorizationFlags> authorizationFlags, FieldSet fieldSet);
    long count(DmpLookup lookup, EnumSet<AuthorizationFlags> authorizationFlags);
    QueryResult<Description> collect(DescriptionLookup lookup, EnumSet<AuthorizationFlags> authorizationFlags, FieldSet fieldSet);
    QueryResult<PublicDescription> collectPublic(DescriptionLookup lookup, EnumSet<AuthorizationFlags> authorizationFlags, FieldSet fieldSet);
    long count(DescriptionLookup lookup, EnumSet<AuthorizationFlags> authorizationFlags);
}