package eu.eudat.service.elastic;

import eu.eudat.data.DescriptionEntity;
import eu.eudat.data.DmpEntity;

import javax.management.InvalidApplicationException;
import java.io.IOException;

public interface ElasticService {
    boolean enabled();
    boolean existsDmpIndex() throws IOException;

    boolean existsDescriptionIndex() throws IOException;

    void ensureDmpIndex() throws IOException;

    void ensureDescriptionIndex() throws IOException;

    void ensureIndexes() throws IOException;

    void persistDmp(DmpEntity dmp) throws IOException;

    void deleteDmp(DmpEntity dmp) throws IOException;

    void persistDescription(DescriptionEntity description) throws IOException, InvalidApplicationException;

    void deleteDescription(DescriptionEntity description) throws IOException, InvalidApplicationException;

	void deleteDmpIndex() throws IOException;

    void deleteDescriptionIndex() throws IOException;

	void resetDmpIndex() throws IOException, InvalidApplicationException;

    void resetDescriptionIndex() throws IOException, InvalidApplicationException;
}
