package eu.eudat.service.keycloak;

import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.boot.context.properties.bind.ConstructorBinding;

import java.util.HashMap;

@ConfigurationProperties(prefix = "keycloak-resources")
@ConditionalOnProperty(prefix = "keycloak-resources", name = "enabled", havingValue = "true")
public class KeycloakResourcesProperties {

    private final HashMap<String, KeycloakAuthorityProperties> authorities;

    @ConstructorBinding
    public KeycloakResourcesProperties(HashMap<String, KeycloakAuthorityProperties> authorities) {
        this.authorities = authorities;
    }

    public HashMap<String, KeycloakAuthorityProperties> getAuthorities() {
        return authorities;
    }

}
