package eu.eudat.service.transformer;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.boot.context.properties.bind.ConstructorBinding;

import java.util.List;

@ConfigurationProperties(prefix = "transformer")
public class FileTransformerProperties {

    private final List<TransformerSource> sources;

    @ConstructorBinding
    public FileTransformerProperties(List<TransformerSource> sources) {
        this.sources = sources;
    }

    public List<TransformerSource> getSources() {
        return sources;
    }

    public static class TransformerSource {

        private final String url;
        private final String transformerId;
        private final String issuerUrl;
        private final String clientId;
        private final String clientSecret;
        private final String scope;

        @ConstructorBinding
        public TransformerSource(String url, String transformerId, String issuerUrl, String clientId, String clientSecret, String scope) {
            this.url = url;
	        this.transformerId = transformerId;
            this.issuerUrl = issuerUrl;
            this.clientId = clientId;
            this.clientSecret = clientSecret;
            this.scope = scope;
        }

        public String getUrl() {
            return url;
        }

        public String getIssuerUrl() {
            return issuerUrl;
        }

        public String getClientId() {
            return clientId;
        }

        public String getClientSecret() {
            return clientSecret;
        }

        public String getScope() {
            return scope;
        }

        public String getTransformerId() {
            return transformerId;
        }
    }
}
