package eu.eudat.service.visibility;

import eu.eudat.commons.types.descriptiontemplate.FieldEntity;
import eu.eudat.commons.types.descriptiontemplate.RuleEntity;

import java.time.Instant;
import java.util.List;

public class RuleWithTarget{
	private final String target;
	private final String source;
	private final String textValue;
	private final List<String> textListValue;
	private final Instant dateValue;
	private final FieldEntity fieldEntity;

	public RuleWithTarget(String source, RuleEntity rule, FieldEntity fieldEntity) {
		this.target = rule.getTarget();
		this.source = source;
		this.fieldEntity = fieldEntity;
		this.textValue = rule.getTextValue();
		this.textListValue = rule.getTextListValue();
		this.dateValue = rule.getDateValue();
	}

	public String getTarget() {
		return target;
	}

	public String getSource() {
		return source;
	}

	public String getTextValue() {
		return textValue;
	}

	public List<String> getTextListValue() {
		return textListValue;
	}

	public Instant getDateValue() {
		return dateValue;
	}

	public FieldEntity getFieldEntity() {
		return fieldEntity;
	}
}
