package eu.eudat.controllers;

import eu.eudat.authorization.Permission;
import eu.eudat.logic.services.ExternalValidationService;
import gr.cite.commons.web.authz.service.AuthorizationService;
import gr.cite.tools.exception.MyNotFoundException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping(path = {"api/validation"})
public class ExternalValidationController {

    private ExternalValidationService externalValidationService;
    private final AuthorizationService authorizationService;

    @Autowired
    public ExternalValidationController(ExternalValidationService externalValidationService, AuthorizationService authorizationService) {
        this.externalValidationService = externalValidationService;
        this.authorizationService = authorizationService;
    }

    @GetMapping(path = {""}, produces = "application/json")
    public @ResponseBody Boolean validate(@RequestParam(value = "query", required = false) String query, @RequestParam(value = "type", required = false) String type
    ) throws  MyNotFoundException {
        this.authorizationService.authorizeForce(Permission.AuthenticatedRole);
        
        return this.externalValidationService.validateIdentifier(query, type);
    }
}
