DO $$DECLARE
   this_version CONSTANT varchar := '00.01.056';
BEGIN
   PERFORM * FROM "DBVersion" WHERE version = this_version;
   IF FOUND THEN RETURN; END IF;

CREATE TABLE IF NOT EXISTS public."ant_EntityUser"
(
    "id" uuid NOT NULL,
    "entity_id" uuid NOT NULL,
    "user_id" uuid NOT NULL,
    "tenant" uuid NOT NULL,
    "created_at" timestamp without time zone NOT NULL,
    "updated_at" timestamp without time zone NOT NULL,
    "is_active" smallint NOT NULL,
    CONSTRAINT "ant_EntityUser_pkey" PRIMARY KEY (id),
    CONSTRAINT "ant_EntityUser_tenant_fkey" FOREIGN KEY ("tenant")
        REFERENCES public."ant_Tenant" (id) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION,
    CONSTRAINT "ant_EntityUser_user_fkey" FOREIGN KEY ("user_id")
        REFERENCES public."ant_User" (id) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION
);

    INSERT INTO public."DBVersion" VALUES ('DMPDB', '00.01.056', '2024-02-20 12:00:00.000000+02', now(), 'Add table ant_EntityUser.');

END$$;