import { Lookup } from '@common/model/lookup';
import { Guid } from '@common/types/guid';
import { IsActive } from '../common/enum/is-active.enum';
import { DescriptionStatus } from '../common/enum/description-status';
import { DmpLookup } from './dmp.lookup';

export class DescriptionLookup extends Lookup implements DescriptionFilter {
	ids: Guid[];
	excludedIds: Guid[];
	like: string;
	createdAfter: Date;
	createdBefore: Date;
	finalizedAfter: Date;
	finalizedBefore: Date;
	dmpSubQuery: DmpLookup;
	isActive: IsActive[];
	statuses: DescriptionStatus[];

	constructor() {
		super();
	}
}

export interface DescriptionFilter {
	ids: Guid[];
	excludedIds: Guid[];
	like: string;
	createdAfter: Date;
	createdBefore: Date;
	finalizedAfter: Date;
	finalizedBefore: Date;
	dmpSubQuery: DmpLookup;
	isActive: IsActive[];
	statuses: DescriptionStatus[];
}
