import { Lookup } from '@common/model/lookup';
import { Guid } from '@common/types/guid';
import { IsActive } from '../common/enum/is-active.enum';
import { DmpBlueprintStatus } from '../common/enum/dmp-blueprint-status';
import { DmpBlueprintVersionStatus } from '../common/enum/dmp-blueprint-version-status';

export class DmpBlueprintLookup extends Lookup implements DmpBlueprintFilter {
	ids: Guid[];
	excludedIds: Guid[];
	like: string;
	isActive: IsActive[];
	statuses: DmpBlueprintStatus[];
	groupIds: Guid[];
	versionStatuses: DmpBlueprintVersionStatus[];

	constructor() {
		super();
	}
}

export interface DmpBlueprintFilter {
	ids: Guid[];
	excludedIds: Guid[];
	like: string;
	isActive: IsActive[];
	statuses: DmpBlueprintStatus[];
	versionStatuses: DmpBlueprintVersionStatus[];
}
