import { Lookup } from '@common/model/lookup';
import { Guid } from '@common/types/guid';
import { DmpAccessType } from '../common/enum/dmp-access-type';
import { DmpStatus } from '../common/enum/dmp-status';
import { DmpVersionStatus } from '../common/enum/dmp-version-status';
import { IsActive } from '../common/enum/is-active.enum';
import { DmpDescriptionTemplateLookup } from './dmp-description-template.lookup';

export class DmpLookup extends Lookup implements DmpFilter {
	ids: Guid[];
	excludedIds: Guid[];
	like: string;
	isActive: IsActive[];
	versionStatuses: DmpVersionStatus[];
	statuses: DmpStatus[];
	accessTypes: DmpAccessType[];
	versions: Number[];
	dmpDescriptionTemplateSubQuery: DmpDescriptionTemplateLookup;
	groupIds: Guid[];

	constructor() {
		super();
	}
}

export interface DmpFilter {
	ids: Guid[];
	excludedIds: Guid[];
	like: string;
	isActive: IsActive[];
	versionStatuses: DmpVersionStatus[];
	statuses: DmpStatus[];
	accessTypes: DmpAccessType[];
	versions: Number[]
	groupIds: Guid[];
}
