import { NgModule } from '@angular/core';
import { LoginComponent } from '@app/ui/auth/login/login.component';
import { LoginRoutingModule } from '@app/ui/auth/login/login.routing';
import { LoginService } from '@app/ui/auth/login/utilities/login.service';
import { Oauth2DialogModule } from '@app/ui/misc/oauth2-dialog/oauth2-dialog.module';
import { CommonFormsModule } from '@common/forms/common-forms.module';
import { CommonUiModule } from '@common/ui/common-ui.module';
import { MergeEmailConfirmation } from './merge-email-confirmation/merge-email-confirmation.component';
import { UnlinkEmailConfirmation } from './unlink-email-confirmation/unlink-email-confirmation.component';
import { PostLoginComponent } from './post-login/post-login.component';

@NgModule({
	imports: [
		CommonUiModule,
		CommonFormsModule,
		LoginRoutingModule,
		Oauth2DialogModule
	],
	declarations: [
		LoginComponent,
		MergeEmailConfirmation,
		UnlinkEmailConfirmation,
		PostLoginComponent
	],
	exports: [
		LoginComponent
	],
	providers: [LoginService]
})
export class LoginModule { }
