import { NgModule } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FormattingModule } from '@app/core/formatting.module';
import { DashboardComponent } from '@app/ui/dashboard/dashboard.component';
import { DashboardRoutingModule } from '@app/ui/dashboard/dashboard.routing';
import { ConfirmationDialogModule } from '@common/modules/confirmation-dialog/confirmation-dialog.module';
import { CommonUiModule } from '@common/ui/common-ui.module';
import { DescriptionListingModule } from '../description/listing/description-listing.module';
import { DmpListingModule } from '../dmp/listing/dmp-listing.module';
import { StartNewDmpDialogModule } from '../dmp/new/start-new-dmp-dialogue/start-new-dmp-dialog.module';
import { DraftsComponent } from './drafts/drafts.component';
import { RecentEditedActivityComponent } from './recent-edited-activity/recent-edited-activity.component';
import { RecentEditedDescriptionActivityComponent } from './recent-edited-description-activity/recent-edited-description-activity.component';
import { RecentEditedDmpActivityComponent } from './recent-edited-dmp-activity/recent-edited-dmp-activity.component';

@NgModule({
	imports: [
		CommonUiModule,
		FormattingModule,
		DashboardRoutingModule,
		ConfirmationDialogModule,
		// DatasetCopyDialogModule,
		FormsModule,
		ReactiveFormsModule,

		DmpListingModule,
		DescriptionListingModule,
		StartNewDmpDialogModule
	],
	declarations: [
		DashboardComponent,
		RecentEditedActivityComponent,
		RecentEditedDmpActivityComponent,
		RecentEditedDescriptionActivityComponent,
		DraftsComponent
	]
})
export class DashboardModule { }
