import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
// import { DescriptionWizardComponent } from './description-wizard/description-wizard.component';
// import { DescriptionOverviewComponent } from './overview/description-overview.component';

const routes: Routes = [
	{
		path: 'overview',
		loadChildren: () => import('./overview/description-overview.module').then(m => m.DescriptionOverviewModule),
		data: {
			breadcrumb: true
		}
	},
	{
		path: 'edit',
		loadChildren: () => import('./editor/description-editor.module').then(m => m.DescriptionEditorModule),
		data: {
			breadcrumb: true
		}
	},
	{
		path: '',
		loadChildren: () => import('./listing/description-listing.module').then(m => m.DescriptionListingModule),
		data: {
			breadcrumb: true
		},
	},
];

@NgModule({
	imports: [RouterModule.forChild(routes)],
	exports: [RouterModule],
	providers: []
})
export class DescriptionRoutingModule { }
