import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
// import { DescriptionWizardComponent } from './description-wizard/description-wizard.component';
import { AppPermission } from '@app/core/common/enum/permission.enum';
import { PendingChangesGuard } from '@common/forms/pending-form-changes/pending-form-changes-guard.service';
// import { DescriptionOverviewComponent } from './overview/description-overview.component';
import { BreadcrumbService } from '@app/ui/misc/breadcrumb/breadcrumb.service';
import { DescriptionEditorComponent } from './description-editor.component';
import { DescriptionEditorResolver } from './description-editor.resolver';
import { AuthGuard } from '@app/core/auth-guard.service';

const routes: Routes = [
	{
		path: ':id',
		canActivate: [AuthGuard],
		component: DescriptionEditorComponent,
		canDeactivate: [PendingChangesGuard],
		resolve: {
			'entity': DescriptionEditorResolver
		},
		data: {
			...BreadcrumbService.generateRouteDataConfiguration({
				title: 'BREADCRUMBS.EDIT-DESCRIPTION'
			})
			// ,
			// authContext: {
			// 	permissions: [AppPermission.EditDescription]
			// }
		}
	},
	{
		path: ':id/finalize',
		canActivate: [AuthGuard],
		component: DescriptionEditorComponent,
		canDeactivate: [PendingChangesGuard],
		resolve: {
			'entity': DescriptionEditorResolver
		},
		data: {
			...BreadcrumbService.generateRouteDataConfiguration({
				title: 'BREADCRUMBS.EDIT-DESCRIPTION'
			})
			// ,
			// authContext: {
			// 	permissions: [AppPermission.EditDescription]
			// }
		}
	},
	{
		path: ':dmpId/:dmpSectionId',
		canActivate: [AuthGuard],
		component: DescriptionEditorComponent,
		canDeactivate: [PendingChangesGuard],
		resolve: {
			'entity': DescriptionEditorResolver
		},
		data: {
			...BreadcrumbService.generateRouteDataConfiguration({
				title: 'BREADCRUMBS.EDIT-DESCRIPTION'
			})
			// ,
			// authContext: {
			// 	permissions: [AppPermission.EditDescription]
			// }
		}
	},
	{
		path: 'copy/:id/:copyDmpId/:dmpSectionId',
		canActivate: [AuthGuard],
		component: DescriptionEditorComponent,
		canDeactivate: [PendingChangesGuard],
		resolve: {
			'entity': DescriptionEditorResolver
		},
		data: {
			...BreadcrumbService.generateRouteDataConfiguration({
				title: 'BREADCRUMBS.EDIT-DESCRIPTION'
			})
			// ,
			// authContext: {
			// 	permissions: [AppPermission.EditDescription]
			// }
		}
	},

	// {
	// 	path: 'edit/:id/finalize',
	// 	component: DescriptionWizardComponent,
	// 	canActivate: [AuthGuard],
	// 	data: {
	// 		breadcrumb: true,
	// 		public: false,
	// 		title: 'GENERAL.TITLES.DATASET-EDIT',
	// 		finalize: true
	// 	},
	// 	canDeactivate:[CanDeactivateGuard]
	// },
	// {
	// 	path: 'publicEdit/:publicId',
	// 	component: DescriptionWizardComponent,
	// 	//canActivate: [AuthGuard],
	// 	data: {
	// 		public: true,
	// 		title: 'GENERAL.TITLES.DATASET-PUBLIC-EDIT'
	// 	},
	// 	canDeactivate:[CanDeactivateGuard]
	// },
	// {
	// 	path: 'new',
	// 	component: DescriptionWizardComponent,
	// 	canActivate: [AuthGuard],
	// 	data: {
	// 		breadcrumb: true,
	// 		title: 'GENERAL.TITLES.DATASET-NEW'
	// 	},
	// 	canDeactivate:[CanDeactivateGuard]
	// },
	// {
	// 	path: 'copy/:id',
	// 	component: DescriptionWizardComponent,
	// 	canActivate: [AuthGuard],
	// 	data: {
	// 		breadcrumb: true,
	// 		title: 'GENERAL.TITLES.DATASET-COPY'
	// 	},
	// 	canDeactivate:[CanDeactivateGuard]
	// },
	// {
	// 	path: 'profileupdate/:updateId',
	// 	component: DescriptionWizardComponent,
	// 	canActivate: [AuthGuard],
	// 	data: {
	// 		breadcrumb: true,
	// 		title: 'GENERAL.TITLES.DATASET-UPDATE'
	// 	},
	// 	canDeactivate:[CanDeactivateGuard]
	// },

];

@NgModule({
	imports: [RouterModule.forChild(routes)],
	exports: [RouterModule],
	providers: [DescriptionEditorResolver]
})
export class DescriptionEditorRoutingModule { }
