import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
// import { DmpWizardComponent } from './description-wizard/description-wizard.component';
import { AppPermission } from '@app/core/common/enum/permission.enum';
import { PendingChangesGuard } from '@common/forms/pending-form-changes/pending-form-changes-guard.service';
// import { DmpOverviewComponent } from './overview/description-overview.component';
import { AuthGuard } from '@app/core/auth-guard.service';
import { BreadcrumbService } from '@app/ui/misc/breadcrumb/breadcrumb.service';
import { DmpEditorComponent } from './dmp-editor.component';
import { DmpEditorResolver } from './dmp-editor.resolver';

const routes: Routes = [
	{
		path: '',
		component: DmpEditorComponent,
		canActivate: [AuthGuard],
		canDeactivate: [PendingChangesGuard],
		data: {
			...BreadcrumbService.generateRouteDataConfiguration({
				title: 'BREADCRUMBS.NEW-DMP'
			}),
			authContext: {
				permissions: [AppPermission.NewDmp]
			}
		}
	},
	{
		path: ':id',
		canActivate: [AuthGuard],
		component: DmpEditorComponent,
		canDeactivate: [PendingChangesGuard],
		resolve: {
			'entity': DmpEditorResolver
		},
		data: {
			...BreadcrumbService.generateRouteDataConfiguration({
				title: 'BREADCRUMBS.EDIT-DMP'
			})
		}
	}

];

@NgModule({
	imports: [RouterModule.forChild(routes)],
	exports: [RouterModule],
	providers: [DmpEditorResolver]
})
export class DmpEditorRoutingModule { }
