import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';

const routes: Routes = [
	{
		path: 'overview',
		loadChildren: () => import('./overview/dmp-overview.module').then(m => m.DmpOverviewModule),
		data: {
			breadcrumb: true
		}
	},
	{
		path: 'new',
		loadChildren: () => import('./dmp-editor-blueprint/dmp-editor.module').then(m => m.DmpEditorModule),
		data: {
			breadcrumb: true
		}
	},
	{
		path: 'edit',
		loadChildren: () => import('./dmp-editor-blueprint/dmp-editor.module').then(m => m.DmpEditorModule),
		data: {
			breadcrumb: true
		}
	},
	{
		path: '',
		loadChildren: () => import('./listing/dmp-listing.module').then(m => m.DmpListingModule),
		data: {
			breadcrumb: true
		},
	},



	// {
	// 	path: 'publicEdit/:publicId',
	// 	component: DmpEditorComponent,
	// 	data: {
	// 		breadcrumb: true,
	// 		title: 'GENERAL.TITLES.DMP-PUBLIC-EDIT'
	// 	},
	// 	canDeactivate: [CanDeactivateGuard]
	// },

	// {
	// 	path: 'publicOverview/:publicId',
	// 	component: DmpOverviewComponent,
	// 	data: {
	// 		breadcrumb: true,
	// 		title: 'GENERAL.TITLES.DMP-OVERVIEW'
	// 	},
	// },




	// {
	// 	path: 'new/dataset',
	// 	component: DmpEditorComponent,
	// 	canActivate: [AuthGuard],
	// 	data: {
	// 		breadcrumbs: 'new/dataset',
	// 		title: 'GENERAL.TITLES.DATASET-NEW'
	// 	}
	// },
	// {
	// 	path: 'new/dataset/:dmpId',
	// 	component: DmpEditorComponent,
	// 	canActivate: [AuthGuard],
	// 	data: {
	// 		breadcrumbs: 'new/dataset',
	// 		title: 'GENERAL.TITLES.DATASET-NEW'
	// 	}
	// },
	// {
	// 	path: 'new_version/:id',
	// 	// component: DmpWizardComponent,
	// 	component: DmpCloneComponent,
	// 	data: {
	// 		clone: false,
	// 		breadcrumb: true,
	// 		title: 'GENERAL.TITLES.DMP-NEW-VERSION'
	// 	},
	// },
	// {
	// 	path: 'clone/:id',
	// 	component: DmpCloneComponent,
	// 	data: {
	// 		clone: false,
	// 		breadcrumb: true,
	// 		title: 'GENERAL.TITLES.DMP-CLONE'
	// 	},
	// },
	// {
	// 	path: 'invitation/:id',
	// 	component: InvitationAcceptedComponent,
	// 	data: {
	// 		breadcrumb: true
	// 	},
	// }
];

@NgModule({
	imports: [RouterModule.forChild(routes)],
	exports: [RouterModule]
})
export class DmpRoutingModule { }
