import { NgModule } from '@angular/core';
import { FormattingModule } from '@app/core/formatting.module';
import { AutoCompleteModule } from '@app/library/auto-complete/auto-complete.module';
import { ConfirmationDialogModule } from '@common/modules/confirmation-dialog/confirmation-dialog.module';
import { DmpRoutingModule } from '@app/ui/dmp/dmp.routing';
import { DmpOverviewModule } from '@app/ui/dmp/overview/dmp-overview.module';
import { CommonFormsModule } from '@common/forms/common-forms.module';
import { FormValidationErrorsDialogModule } from '@common/forms/form-validation-errors-dialog/form-validation-errors-dialog.module';
import { CommonUiModule } from '@common/ui/common-ui.module';
import { MultipleChoiceDialogModule } from '@common/modules/multiple-choice-dialog/multiple-choice-dialog.module';
import { DatasetEditorDetailsComponent } from './dataset-editor-details.component';


@NgModule({
    imports: [
        CommonUiModule,
        CommonFormsModule,
        ConfirmationDialogModule,
        FormattingModule,
        AutoCompleteModule,
        DmpRoutingModule,
        DmpOverviewModule,
        FormValidationErrorsDialogModule,
        MultipleChoiceDialogModule,
    ],
    declarations: [
        DatasetEditorDetailsComponent
    ],
    exports: [
        DatasetEditorDetailsComponent
    ]
})
export class DatasetEditorDetailsModule { }
