import { NgModule } from '@angular/core';
import { FormattingModule } from '@app/core/formatting.module';
import { DmpListingComponent } from '@app/ui/dmp/listing/dmp-listing.component';
import { DmpListingItemComponent } from '@app/ui/dmp/listing/listing-item/dmp-listing-item.component';
import { CommonFormsModule } from '@common/forms/common-forms.module';
import { CommonUiModule } from '@common/ui/common-ui.module';
import { CloneDmpDialogModule } from '../clone-dialog/dmp-clone-dialog.module';
import { NewVersionDmpDialogModule } from '../new-version-dialog/dmp-new-version-dialog.module';
import { DmpListingRoutingModule } from './dmp-listing.routing';
import { DmpInvitationDialogModule } from '../invitation/dialog/dmp-invitation-dialog.module';

@NgModule({
	imports: [
		CommonUiModule,
		CommonFormsModule,
		FormattingModule,
		CloneDmpDialogModule,
		NewVersionDmpDialogModule,
		DmpInvitationDialogModule,
		DmpListingRoutingModule
	],
	declarations: [
		DmpListingComponent,
		DmpListingItemComponent,
	],
	exports: [
		DmpListingItemComponent
	]
})
export class DmpListingModule { }
