import { NgModule } from '@angular/core';
import { FormattingModule } from '@app/core/formatting.module';
import { AutoCompleteModule } from '@app/library/auto-complete/auto-complete.module';
import { DmpDepositDropdown } from "@app/ui/dmp/editor/dmp-deposit-dropdown/dmp-deposit-dropdown.component";
import { DmpOverviewComponent } from '@app/ui/dmp/overview/dmp-overview.component';
import { CommonFormsModule } from '@common/forms/common-forms.module';
import { ConfirmationDialogModule } from '@common/modules/confirmation-dialog/confirmation-dialog.module';
import { CommonUiModule } from '@common/ui/common-ui.module';
import { NgDialogAnimationService } from 'ng-dialog-animation';
import { DmpFinalizeDialogModule } from '../dmp-finalize-dialog/dmp-finalize-dialog.module';
import { DmpOverviewRoutingModule } from './dmp-overview.routing';
import { MultipleChoiceDialogModule } from '@common/modules/multiple-choice-dialog/multiple-choice-dialog.module';

@NgModule({
	imports: [
		CommonUiModule,
		CommonFormsModule,
		ConfirmationDialogModule,
		MultipleChoiceDialogModule,
		FormattingModule,
		AutoCompleteModule,
		DmpOverviewRoutingModule,
		DmpFinalizeDialogModule
	],
	declarations: [
		DmpOverviewComponent,
		DmpDepositDropdown
	],
	providers: [
		NgDialogAnimationService
	]
})
export class DmpOverviewModule { }
