import { NgModule } from '@angular/core';
import { EditorModule } from '@tinymce/tinymce-angular';
import { SupportiveMaterialEditorRoutingModule } from './supportive-material-editor.routing';
import { SupportiveMaterialEditorComponent } from './supportive-material-editor.component';
import { CommonUiModule } from '@common/ui/common-ui.module';
import { CommonFormsModule } from '@common/forms/common-forms.module';
import { DatePipe } from '@angular/common';
import { EnumUtils } from '@app/core/services/utilities/enum-utils.service';


@NgModule({
  declarations: [SupportiveMaterialEditorComponent],
  imports: [
	CommonUiModule,
	CommonFormsModule,
	SupportiveMaterialEditorRoutingModule,
	EditorModule
  ],
  providers: [
    DatePipe,
	EnumUtils
  ],
})
export class SupportiveMaterialEditorModule { }
