package eu.old.eudat.data.dao.entities;

import eu.old.eudat.data.dao.DatabaseAccess;
import eu.old.eudat.data.dao.databaselayer.service.DatabaseService;
import eu.old.eudat.data.entities.DatasetDataRepository;
import eu.old.eudat.queryable.QueryableList;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Component;

import java.util.UUID;
import java.util.concurrent.CompletableFuture;

@Component
public class DatasetDataRepositoryDaoImpl extends DatabaseAccess<DatasetDataRepository> implements DatasetDataRepositoryDao{

    public DatasetDataRepositoryDaoImpl(DatabaseService<DatasetDataRepository> databaseService) {
        super(databaseService);
    }

    @Override
    public DatasetDataRepository createOrUpdate(DatasetDataRepository item) {
        return this.getDatabaseService().createOrUpdate(item,DatasetDataRepository.class);
    }

    @Override
    public CompletableFuture<DatasetDataRepository> createOrUpdateAsync(DatasetDataRepository item) {
        return CompletableFuture.supplyAsync(() -> this.createOrUpdate(item));
    }

    @Override
    @Async
    public DatasetDataRepository find(UUID id) {
        return getDatabaseService().getQueryable(DatasetDataRepository.class).where((builder, root) -> builder.equal(root.get("id"), id)).getSingle();
    }

    @Override
    public DatasetDataRepository find(UUID id, String hint) {
        throw new UnsupportedOperationException();
    }


    @Override
    public void delete(DatasetDataRepository item) {
        this.getDatabaseService().delete(item);
    }

    @Override
    public QueryableList<DatasetDataRepository> asQueryable() {
        return this.getDatabaseService().getQueryable(DatasetDataRepository.class);
    }
}
