package eu.old.eudat.data.dao.entities;

import eu.old.eudat.data.dao.DatabaseAccess;
import eu.old.eudat.data.dao.databaselayer.service.DatabaseService;
import eu.old.eudat.data.entities.DatasetRegistry;
import eu.old.eudat.queryable.QueryableList;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Component;

import java.util.UUID;
import java.util.concurrent.CompletableFuture;

@Component
public class DatasetRegistryDaoImpl extends DatabaseAccess<DatasetRegistry> implements DatasetRegistryDao {

    public DatasetRegistryDaoImpl(DatabaseService<DatasetRegistry> databaseService) {
        super(databaseService);
    }

    @Override
    public DatasetRegistry createOrUpdate(DatasetRegistry item) {
        return this.getDatabaseService().createOrUpdate(item,DatasetRegistry.class);
    }

    @Override
    public CompletableFuture<DatasetRegistry> createOrUpdateAsync(DatasetRegistry item) {
        return CompletableFuture.supplyAsync(() -> this.createOrUpdate(item));
    }

    @Override
    @Async
    public DatasetRegistry find(UUID id) {
        return getDatabaseService().getQueryable(DatasetRegistry.class).where((builder, root) -> builder.equal(root.get("id"), id)).getSingle();
    }

    @Override
    public DatasetRegistry find(UUID id, String hint) {
        throw new UnsupportedOperationException();
    }


    @Override
    public void delete(DatasetRegistry item) {
        this.getDatabaseService().delete(item);
    }

    @Override
    public QueryableList<DatasetRegistry> asQueryable() {
        return this.getDatabaseService().getQueryable(DatasetRegistry.class);
    }
}
