package eu.old.eudat.controllers;

import eu.old.eudat.logic.managers.CommonsManager;
import eu.old.eudat.logic.proxy.config.configloaders.ConfigLoader;
import eu.old.eudat.models.data.externalurl.ExternalSourcesConfiguration;
import eu.old.eudat.models.data.helpers.responses.ResponseItem;
import eu.old.eudat.types.ApiMessageCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

/**
 * Created by ikalyvas on 3/28/2018.
 */
@RestController
@CrossOrigin
@RequestMapping(value = {"/api/common"})
public class CommonController {

    private ConfigLoader configLoader;

    @Autowired
    public CommonController(ConfigLoader configLoader) {
        this.configLoader = configLoader;
    }

    @RequestMapping(method = RequestMethod.GET, value = {"/externalSourcesConfiguration"}, produces = "application/json")
    public @ResponseBody
    ResponseEntity<ResponseItem<ExternalSourcesConfiguration>> getExternalSourcesConfiguration() {
        ExternalSourcesConfiguration configuration = CommonsManager.getExternalSourcesConfiguration(configLoader);
        return ResponseEntity.status(HttpStatus.OK).body(new ResponseItem<ExternalSourcesConfiguration>().status(ApiMessageCode.NO_MESSAGE).payload(configuration));
    }
}
