package eu.old.eudat.controllers;

import eu.old.eudat.data.query.items.item.researcher.ResearcherCriteriaRequest;
import eu.old.eudat.logic.managers.ResearcherManager;
import eu.old.eudat.logic.proxy.config.exceptions.HugeResultSet;
import eu.old.eudat.logic.proxy.config.exceptions.NoURLFound;
import eu.old.eudat.logic.services.ApiContext;
import eu.old.eudat.models.data.dmp.Researcher;
import eu.old.eudat.models.data.helpers.responses.ResponseItem;
import eu.old.eudat.models.data.security.Principal;
import eu.old.eudat.types.ApiMessageCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@CrossOrigin
@RequestMapping(value = {"/api/researchers"})

public class Researchers extends BaseController {

    private ResearcherManager researcherManager;
    @Autowired
    public Researchers(ApiContext apiContext, ResearcherManager researcherManager) {
        super(apiContext);
        this.researcherManager = researcherManager;
    }

    @RequestMapping(method = RequestMethod.POST, value = {"/getWithExternal"}, consumes = "application/json", produces = "application/json")
    public @ResponseBody
    ResponseEntity<ResponseItem<List<Researcher>>> getWithExternal(@RequestBody ResearcherCriteriaRequest researcherCriteriaRequest, Principal principal) throws HugeResultSet, NoURLFound {
        List<Researcher> dataTable = this.researcherManager.getCriteriaWithExternal(researcherCriteriaRequest, principal);
        return ResponseEntity.status(HttpStatus.OK).body(new ResponseItem<List<Researcher>>().payload(dataTable).status(ApiMessageCode.NO_MESSAGE));
    }

    @Transactional
    @RequestMapping(method = RequestMethod.POST, consumes = "application/json", produces = "application/json")
    public @ResponseBody
    ResponseEntity<ResponseItem<Researcher>> create(@RequestBody eu.old.eudat.models.data.researcher.Researcher researcher, Principal principal) throws Exception {
        this.researcherManager.create(researcher, principal);
        return ResponseEntity.status(HttpStatus.OK).body(new ResponseItem<Researcher>().status(ApiMessageCode.SUCCESS_MESSAGE));
    }

}

