package eu.old.eudat.logic.utilities.helpers;

import eu.old.eudat.models.data.user.components.commons.Rule;
import eu.old.eudat.models.data.entities.xmlmodels.datasetprofiledefinition.Section;

import java.util.LinkedList;
import java.util.List;
import java.util.stream.Collectors;

public class ModelBuilderCollector {


    /**
     * @param sections
     * @return
     */
    public static List<Rule> collectRules(List<Section> sections) {
        List<Rule> rules = new LinkedList();
        for (Section section : sections) {
            if (!section.getSections().isEmpty()) {
                rules.addAll(collectRules(section.getSections()));
            }
            rules.addAll(
                    section.getFieldSets().stream()
                            .map(fieldset -> fieldset.getFields())
                            .flatMap(List::stream)
                            .map(field -> getRulesFromField(field.getId(), field.getVisible()
                                    .getRules()))
                            .flatMap(List::stream)
                            .collect(Collectors.toList()));
        }

        return rules;
    }

    private static List<Rule> getRulesFromField(String id, List<eu.old.eudat.models.data.components.commons.Rule> rules) {
        List<Rule> modelRules = new LinkedList();
        for (eu.old.eudat.models.data.components.commons.Rule rule : rules) {
            Rule modelRule = new Rule().fromDefinitionRule(rule);
            modelRule.setSourceField(id);
            modelRules.add(modelRule);
        }
        return modelRules;
    }

}
