package gr.cite.notification.web.scope.user;

import gr.cite.notification.convention.ConventionService;
import gr.cite.tools.cache.CacheService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.UUID;

@Service
public class UserInterceptorCacheService extends CacheService<UserInterceptorCacheService.UserInterceptorCacheValue> {

    public static class UserInterceptorCacheValue {

        public UserInterceptorCacheValue() {
        }

        public UserInterceptorCacheValue(String subjectId, UUID userId) {
            this.subjectId = subjectId;
            this.userId = userId;
        }


        public String getSubjectId() {
            return subjectId;
        }

        public void setSubjectId(String subjectId) {
            this.subjectId = subjectId;
        }

        private String subjectId;
        private UUID userId;

        public UUID getUserId() {
            return userId;
        }

        public void setUserId(UUID userId) {
            this.userId = userId;
        }
    }


    @Autowired
    public UserInterceptorCacheService(UserInterceptorCacheOptions options, ConventionService conventionService) {
        super(options);
    }

    @Override
    protected Class<UserInterceptorCacheValue> valueClass() {
        return UserInterceptorCacheValue.class;
    }

    @Override
    public String keyOf(UserInterceptorCacheValue value) {
        return this.buildKey(value.getSubjectId());
    }


    public String buildKey(String subject) {
        HashMap<String, String> keyParts = new HashMap<>();
        keyParts.put("$subject$", subject);
        return this.generateKey(keyParts);
    }
}
