package gr.cite.notification.common.enums;

import com.fasterxml.jackson.annotation.JsonValue;
import gr.cite.notification.data.conventers.DatabaseEnum;

import java.util.Map;

public enum EmailOverrideMode implements DatabaseEnum<Short> {
	NotOverride((short)0),
	Additive((short)1),
	Replace((short)2);

	private final Short value;

	EmailOverrideMode(Short value) {
		this.value = value;
	}

	@JsonValue
	public Short getValue() {
		return value;
	}

	private static final Map<Short, EmailOverrideMode> map = EnumUtils.getEnumValueMap(EmailOverrideMode.class);

	public static EmailOverrideMode of(Short i) {
		return map.get(i);
	}
}
