package gr.cite.notification.common.enums;

import com.fasterxml.jackson.annotation.JsonValue;
import gr.cite.notification.data.conventers.DatabaseEnum;

import java.util.Map;

public enum InAppNotificationPriority implements DatabaseEnum<Short> {
    LOW((short)-1),
    NORMAL((short)0),
    HIGH((short)1),
    EMERGENCY((short)2);

    private final Short value;

    InAppNotificationPriority(Short value) {
        this.value = value;
    }

    @JsonValue
    public Short getValue() {
        return value;
    }

    private static final Map<Short, InAppNotificationPriority> map = EnumUtils.getEnumValueMap(InAppNotificationPriority.class);

    public static InAppNotificationPriority of(Short i) {
        return map.get(i);
    }
}
