package gr.cite.notification.common.enums;

import com.fasterxml.jackson.annotation.JsonValue;
import gr.cite.notification.data.conventers.DatabaseEnum;

import java.util.Map;

public enum NotificationDataType implements DatabaseEnum<Short> {
	Integer((short)0),
	Decimal((short)1),
	Double((short)2),
	DateTime((short)3),
	//TimeSpan(4),
	String((short)5);
	private final Short value;

	NotificationDataType(Short value) {
		this.value = value;
	}

	@JsonValue
	public Short getValue() {
		return value;
	}

	private static final Map<Short, NotificationDataType> map = EnumUtils.getEnumValueMap(NotificationDataType.class);

	public static NotificationDataType of(Short i) {
		return map.get(i);
	}
}
