package gr.cite.notification.common.enums;

import com.fasterxml.jackson.annotation.JsonValue;
import gr.cite.notification.data.conventers.DatabaseEnum;

import java.util.Map;

public enum NotificationTemplateChannel implements DatabaseEnum<Short> {

    Email((short)0),
    InApp((short)1);

    private final Short value;

    NotificationTemplateChannel(Short value) {
        this.value = value;
    }

    @JsonValue
    public Short getValue() {
        return value;
    }

    private static final Map<Short, NotificationTemplateChannel> map = EnumUtils.getEnumValueMap(NotificationTemplateChannel.class);

    public static NotificationTemplateChannel of(Short i) {
        return map.get(i);
    }

}
