package gr.cite.notification.common.enums;

import com.fasterxml.jackson.annotation.JsonValue;
import gr.cite.notification.data.conventers.DatabaseEnum;

import java.util.Map;

public enum NotificationTemplateKind implements DatabaseEnum<Short> {

    Draft((short)0),
    Secondary((short)1),
    Primary((short)2),
    Default((short)3);

    private final Short value;

    NotificationTemplateKind(Short value) {
        this.value = value;
    }

    @JsonValue
    public Short getValue() {
        return value;
    }

    private static final Map<Short, NotificationTemplateKind> map = EnumUtils.getEnumValueMap(NotificationTemplateKind.class);

    public static NotificationTemplateKind of(Short i) {
        return map.get(i);
    }

}
