package gr.cite.notification.common.enums;

import com.fasterxml.jackson.annotation.JsonValue;
import gr.cite.notification.data.conventers.DatabaseEnum;

import java.util.Map;

public enum NotificationTrackingState implements DatabaseEnum<Short> {
    /* *
    * Initial state
    */
    UNDEFINED((short)0),
    /* *
    * Final for notifiers that do not provide any kind of tracking
    */
    NA((short)1),
    QUEUED((short)2),
    SENT((short)3),
    DELIVERED((short)4),
    UNDELIVERED((short)5),
    FAILED((short)6),
    UNSENT((short)7);

    private final Short value;

    NotificationTrackingState(Short value) {
        this.value = value;
    }

    @JsonValue
    public Short getValue() {
        return value;
    }

    private static final Map<Short, NotificationTrackingState> map = EnumUtils.getEnumValueMap(NotificationTrackingState.class);

    public static NotificationTrackingState of(Short i) {
        return map.get(i);
    }
}
