package gr.cite.notification.data;

import gr.cite.notification.common.enums.InAppNotificationPriority;
import gr.cite.notification.common.enums.IsActive;
import gr.cite.notification.common.enums.NotificationInAppTracking;
import gr.cite.notification.data.conventers.InAppNotificationPriorityConverter;
import gr.cite.notification.data.conventers.IsActiveConverter;
import gr.cite.notification.data.conventers.NotificationInAppTrackingConverter;
import gr.cite.notification.data.tenant.TenantScopedBaseEntity;
import jakarta.persistence.*;

import java.time.Instant;
import java.util.UUID;

@Entity
@Table(name = "\"InAppNotification\"")
public class InAppNotificationEntity extends TenantScopedBaseEntity {

    @Id
    @Column(name = "\"id\"", columnDefinition = "uuid", nullable = false)
    private UUID id;

    public static final String _id = "id";

    @Column(name = "\"user\"", columnDefinition = "uuid", nullable = false)
    private UUID userId;

    public static final String _userId = "userId";

    @Column(name = "\"type\"", columnDefinition = "uuid", nullable = false)
    private UUID type;

    public static final String _type = "type";

    @Column(name = "\"read_time\"")
    private Instant readTime;

    public static final String _readTime = "readTime";

    @Column(name = "\"tracking_state\"", nullable = false)
    @Convert(converter = NotificationInAppTrackingConverter.class)
    private NotificationInAppTracking trackingState;

    public static final String _trackingState = "trackingState";

    @Column(name = "\"priority\"", nullable = false)
    @Convert(converter = InAppNotificationPriorityConverter.class)
    private InAppNotificationPriority priority;

    public static final String _priority = "priority";

    @Column(name = "\"subject\"")
    private String subject;

    public static final String _subject = "subject";

    @Column(name = "\"body\"")
    private String body;

    public static final String _body = "body";

    @Column(name = "\"extra_data\"")
    private String extraData;

    public static final String _extraData = "extraData";

    @Column(name = "\"created_at\"", nullable = false)
    private Instant createdAt;

    public static final String _createdAt = "createdAt";

    @Column(name = "\"updated_at\"", nullable = false)
    @Version
    private Instant updatedAt;

    public static final String _updatedAt = "updatedAt";

    @Column(name = "\"is_active\"", nullable = false)
    @Convert(converter = IsActiveConverter.class)
    private IsActive isActive;

    public static final String _isActive = "isActive";

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    public UUID getUserId() {
        return userId;
    }

    public void setUserId(UUID userId) {
        this.userId = userId;
    }

    public UUID getType() {
        return type;
    }

    public void setType(UUID type) {
        this.type = type;
    }

    public Instant getReadTime() {
        return readTime;
    }

    public void setReadTime(Instant readTime) {
        this.readTime = readTime;
    }

    public NotificationInAppTracking getTrackingState() {
        return trackingState;
    }

    public void setTrackingState(NotificationInAppTracking trackingState) {
        this.trackingState = trackingState;
    }

    public InAppNotificationPriority getPriority() {
        return priority;
    }

    public void setPriority(InAppNotificationPriority priority) {
        this.priority = priority;
    }

    public String getSubject() {
        return subject;
    }

    public void setSubject(String subject) {
        this.subject = subject;
    }

    public String getBody() {
        return body;
    }

    public void setBody(String body) {
        this.body = body;
    }

    public String getExtraData() {
        return extraData;
    }

    public void setExtraData(String extraData) {
        this.extraData = extraData;
    }

    public Instant getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Instant createdAt) {
        this.createdAt = createdAt;
    }

    public Instant getUpdatedAt() {
        return updatedAt;
    }

    public void setUpdatedAt(Instant updatedAt) {
        this.updatedAt = updatedAt;
    }

    public IsActive getIsActive() {
        return isActive;
    }

    public void setIsActive(IsActive isActive) {
        this.isActive = isActive;
    }
}
