package gr.cite.notification.integrationevent.inbox;

import org.springframework.boot.context.properties.ConfigurationProperties;

import java.util.List;

@ConfigurationProperties(prefix = "queue.task.listener.options")
public class InboxProperties {

    private final String exchange;

    private final List<String> notifyTopic;

    private final List<String> tenantRemovalTopic;

    private final List<String> tenantTouchedTopic;

    private final List<String> userRemovalTopic;

    private final List<String> userTouchedTopic;

    public InboxProperties(
            String exchange,
            List<String> notifyTopic,
            List<String> tenantRemovalTopic,
            List<String> tenantTouchedTopic,
            List<String> userRemovalTopic,
            List<String> userTouchedTopic) {
        this.exchange = exchange;
        this.notifyTopic = notifyTopic;
        this.tenantRemovalTopic = tenantRemovalTopic;
        this.tenantTouchedTopic = tenantTouchedTopic;
        this.userRemovalTopic = userRemovalTopic;
        this.userTouchedTopic = userTouchedTopic;
    }

    public List<String> getNotifyTopic() {
        return notifyTopic;
    }

    public List<String> getTenantRemovalTopic() {
        return tenantRemovalTopic;
    }

    public List<String> getTenantTouchedTopic() {
        return tenantTouchedTopic;
    }

    public List<String> getUserRemovalTopic() {
        return userRemovalTopic;
    }

    public List<String> getUserTouchedTopic() {
        return userTouchedTopic;
    }

    public String getExchange() {
        return exchange;
    }

}
