package gr.cite.notification.query.lookup;

import gr.cite.notification.common.enums.IsActive;
import gr.cite.notification.common.enums.NotificationTemplateChannel;
import gr.cite.notification.common.enums.NotificationTemplateKind;
import gr.cite.notification.query.NotificationTemplateQuery;
import gr.cite.tools.data.query.Lookup;
import gr.cite.tools.data.query.QueryFactory;

import java.util.List;
import java.util.UUID;

public class NotificationTemplateLookup extends Lookup {

    private List<IsActive> isActive;

    private List<UUID> notificationTypes;

    private List<NotificationTemplateChannel> channels;

    private List<NotificationTemplateKind> kinds;

    private List<UUID> ids;

    private List<UUID> excludedIds;

    public List<IsActive> getIsActive() {
        return isActive;
    }

    public List<UUID> getNotificationTypes() {
        return notificationTypes;
    }

    public void setNotificationTypes(List<UUID> notificationTypes) {
        this.notificationTypes = notificationTypes;
    }

    public void setIsActive(List<IsActive> isActive) {
        this.isActive = isActive;
    }

    public List<NotificationTemplateChannel> getChannels() {
        return channels;
    }

    public void setChannels(List<NotificationTemplateChannel> channels) {
        this.channels = channels;
    }

    public List<NotificationTemplateKind> getKinds() {
        return kinds;
    }

    public void setKinds(List<NotificationTemplateKind> kinds) {
        this.kinds = kinds;
    }

    public List<UUID> getIds() {
        return ids;
    }

    public void setIds(List<UUID> ids) {
        this.ids = ids;
    }

    public List<UUID> getExcludedIds() {
        return excludedIds;
    }

    public void setExcludedIds(List<UUID> excludedIds) {
        this.excludedIds = excludedIds;
    }

    public NotificationTemplateQuery enrich(QueryFactory queryFactory) {
        NotificationTemplateQuery query = queryFactory.query(NotificationTemplateQuery.class);
        if (this.ids != null) query.ids(this.ids);
        if (this.excludedIds != null) query.excludedIds(this.excludedIds);
        if (this.notificationTypes != null) query.notificationTypes(this.notificationTypes);
        if (this.isActive != null) query.isActive(this.isActive);
        if (this.channels != null) query.channels(this.channels);
        if (this.kinds != null) query.kinds(this.kinds);

        this.enrichCommon(query);

        return query;
    }

}
