package gr.cite.notification.query.lookup;

import gr.cite.notification.common.enums.IsActive;
import gr.cite.notification.query.UserContactInfoQuery;
import gr.cite.tools.data.query.Lookup;
import gr.cite.tools.data.query.QueryFactory;

import java.util.List;
import java.util.UUID;

public class UserContactInfoLookup extends Lookup {

    private List<IsActive> isActive;
    private List<UUID> userIds;
    public List<IsActive> getIsActive() {
        return isActive;
    }

    public void setIsActive(List<IsActive> isActive) {
        this.isActive = isActive;
    }

    public List<UUID> getUserIds() {
        return userIds;
    }

    public void setUserIds(List<UUID> userIds) {
        this.userIds = userIds;
    }


    public UserContactInfoQuery enrich(QueryFactory queryFactory) {
        UserContactInfoQuery query = queryFactory.query(UserContactInfoQuery.class);
        if (this.isActive != null) query.isActive(this.isActive);
        if (this.userIds != null) query.userIds(this.userIds);
        this.enrichCommon(query);

        return query;
    }

}
